unit ctunit;

{$R-,S-,I-,E-,N-}
{$IFDEF DEBUG}
{$D+,L+}
{$ELSE}
{$D-,L-}
{$ENDIF}

interface

uses
  crt,
  dos,
  decl;

procedure ctvoiceadd(p : pointer);

procedure ctvoice(var regs : registers);

procedure chargectvoice;

procedure chargevoc(s : string);

procedure chargevdat(s : string;a : longint);

procedure coupevoc;

procedure arretect;

implementation

{$F+}

{$L CT-INTER}

procedure ctvoiceadd(p : pointer);
external;

procedure ctvoice(var regs : registers);
external;

{$F-}

procedure chargectvoice;
var
  off,sg : word;
begin
  if vocpro then assign(ctf,'CT-VOICE.PRO') else assign(ctf,'CT-VOICE.NOR');
  reset(ctf,1);
  ctsize := filesize(ctf);
  if maxavail<ctsize+16 then begin
    textattr := $1C;
    writeln('Erreur: mmoire insuffisante pour charger CT-VOICE');
    writeln('(Essayez avec /NOVOC)');
  end;
  getmem(ctpointer,ctsize+16);
  off := ofs(ctpointer^);
  sg := seg(ctpointer^);
  sg := sg+off shr 4;
  off := off and $0F;
  if off<>0 then begin
    inc(sg);
    off := 0;
  end;
  ctptr := ptr(sg,off);
  blockread(ctf,ctptr^,ctsize);
  close(ctf);
  if ioresult=0 then begin
    ctok := true;
    ctvoiceadd(ctptr);
    regs.bx := 1;
    regs.ax := vocport;
    ctvoice(regs);
    regs.bx := 2;
    regs.ax := vocirq;
    ctvoice(regs);
    regs.bx := 19;
    regs.ax := vocdma;
    ctvoice(regs);
    regs.bx := 3;
    ctvoice(regs);
    if regs.ax<>0 then begin
      ctok := false;
      exit;
    end;
    regs.bx := 5;
    regs.es := seg(ctstatus);
    regs.di := ofs(ctstatus);
    ctvoice(regs);
  end else begin
    ctok := false;
    close(ctf);
    io := ioresult;
  end;
end;

procedure chargevoc(s : string);
var
  len : longint;
  t : word;
begin
  if novoc then exit;
  assign(vocf,s+'.VOC');
  reset(vocf,1);
  seek(vocf,$14);
  blockread(vocf,t,2);
  len := filesize(vocf)-t;
  if len>=65520 then begin
    io := ioresult;
    vocok := false;
    ctstatus := 0;
    exit;
  end;
  seek(vocf,t);
  blockread(vocf,vocp^,len);
  close(vocf);
  vocok := ioresult=0;
  if not vocok then begin
    ctstatus := 0;
    exit;
  end;
  regs.bx := 6;
  regs.es := seg(vocp^);
  regs.di := ofs(vocp^);
  ctvoice(regs);
end;

procedure chargevdat(s : string;a : longint);
var
  add,len : longint;
  t : word;
begin
  if novoc then exit;
  assign(vocf,s+'.DAT');
  reset(vocf,1);
  seek(vocf,a);
  blockread(vocf,add,4);
  blockread(vocf,len,4);
  if len>=65520 then begin
    io := ioresult;
    vocok := false;
    ctstatus := 0;
    exit;
  end;
  seek(vocf,add+$14);
  blockread(vocf,t,2);
  seek(vocf,add+t);
  blockread(vocf,vocp^,len);
  close(vocf);
  vocok := ioresult=0;
  if not vocok then begin
    ctstatus := 0;
    exit;
  end;
  regs.bx := 6;
  regs.es := seg(vocp^);
  regs.di := ofs(vocp^);
  ctvoice(regs);
end;

procedure coupevoc;
begin
  if novoc then exit;
  regs.bx := 8;
  ctvoice(regs);
end;

procedure arretect;
begin
  if novoc then exit;
  regs.bx := 9;
  ctvoice(regs);
end;

end.