unit decl;

{$R-,S-,I-,E-,N-}
{$IFDEF DEBUG}
{$D+,L+}
{$ELSE}
{$D-,L-}
{$ENDIF}

interface

uses
  crt,
  dos;

const
  basecheck = $340D80AE;
  anticheat = $C8324E83;

type
  corptype = array[0..19] of integer;
  personnage = record
    nom : string;
    sexe : boolean;
    pv,pm : longint;
    pvm,pmm : longint;
    exp,nivno : longint;
    paa,pad : longint;
    race : byte;
    niv : array[1..3] of word;
    frc,int,dex : integer;
    aureum,orenbanque : longint;
    imposable,impot : longint;
    gentillesse : longint;
    pbien,pmal,ploi : longint;
    nequipt : byte;
    equipt : array[0..31] of record
      code : byte;
      quan : word;
      domm : integer;
      portee,maudite : boolean;
      bonfrc,bonint,bondex : integer;
      sstype : byte;
      charges : integer;
      reserved : array[3..15] of byte;
    end;
    corpus : corptype;
    armdomtot : integer;
    armurdomtot : integer;
    empoisonne,existe : boolean;
    faim,sommeil : longint;
    malad : longint;
    sorts : array[0..255] of boolean;
    durees : array[0..255] of word;
  end;
  ligne = array[0..149] of record a,b : byte; end;

const
  nbmonstres = 32;
  nbicos = 89;

const
  races : array[1..nbmonstres] of record
    nom : string[30];
    art : string[4];
    bf,bi,bd : integer;
    adt,audt : integer;
    sorts : boolean;
    mtype : byte;
      { 0 = cratures neutres et intelligentes
        1 = cratures bonnes et intelligentes
        2 = cratures mauvaises et intelligentes
        3 = cratures stupides
        4 = cratures du Neutre
        5 = cratures du Bien
        6 = cratures du Mal
        7 = cratures de la Loi
        255=cratures  gentillesse fixe (p.e. roi de l'enfer)}
    gen : longint;
  end = ((nom:'Homme';art:'un ';bf:0;bi:0;bd:0;adt:0;audt:0;
    sorts:true;mtype:1;gen:0),
  (nom:'Elfe';art:'un ';bf:-4;bi:3;bd:1;adt:0;audt:0;
    sorts:true;mtype:1;gen:100),
  (nom:'Nain';art:'un ';bf:3;bi:-4;bd:1;adt:0;audt:2;
    sorts:false;mtype:0;gen:200),
  (nom:'Gnome';art:'un ';bf:1;bi:-4;bd:3;adt:-1;audt:1;
    sorts:false;mtype:0;gen:100),
  (nom:'Orque';art:'un ';bf:6;bi:-8;bd:2;adt:4;audt:2;
    sorts:false;mtype:2;gen:200),
  (nom:'Lycanthrope';art:'un ';bf:8;bi:-12;bd:4;adt:2;audt:4;
    sorts:false;mtype:2;gen:100),
  (nom:'Gobelin';art:'un ';bf:7;bi:-8;bd:1;adt:2;audt:-2;
    sorts:false;mtype:2;gen:100),
  (nom:'Gorille';art:'un ';bf:8;bi:-12;bd:3;adt:10;audt:12;
    sorts:false;mtype:3),
  (nom:'Crapaud des cavernes';art:'un ';bf:4;bi:-12;bd:2;adt:2;audt:-8;
    sorts:false;mtype:3),
  (nom:'Gupe gante';art:'une ';bf:4;bi:-12;bd:-10;adt:15;audt:4;
    sorts:false;mtype:3),
  (nom:'Loup';art:'un ';bf:7;bi:-12;bd:5;adt:6;audt:0;
    sorts:false;mtype:3),
  (nom:'Scorpion gant';art:'un ';bf:2;bi:-12;bd:-20;adt:50;audt:10;
    sorts:false;mtype:3),
  (nom:'Criquet gant';art:'un ';bf:3;bi:-12;bd:0;adt:0;audt:20;
    sorts:false;mtype:3),
  (nom:'Griffon';art:'un ';bf:20;bi:20;bd:30;adt:20;audt:20;
    sorts:false;mtype:4),
  (nom:'Centaure';art:'un ';bf:36;bi:8;bd:35;adt:12;audt:0;
    sorts:false;mtype:4),
  (nom:'Cyclope';art:'un ';bf:55;bi:-10;bd:10;adt:65;audt:80;
    sorts:false;mtype:4),
  (nom:'Chevalier du Chaos';art:'un ';bf:50;bi:0;bd:70;adt:60;audt:70;
    sorts:false;mtype:6),
  (nom:'Dragon';art:'un ';bf:80;bi:80;bd:25;adt:150;audt:180;
    sorts:true;mtype:4),
  (nom:'Grande bte';art:'une ';bf:100;bi:20;bd:80;adt:100;audt:120;
    sorts:true;mtype:6),
  (nom:'Liche';art:'une ';bf:120;bi:30;bd:100;adt:90;audt:90;
    sorts:true;mtype:6),
  (nom:'Dmon';art:'un ';bf:200;bi:70;bd:150;adt:140;audt:160;
    sorts:true;mtype:6),
  (nom:'Diable';art:'un ';bf:250;bi:150;bd:200;adt:200;audt:180;
    sorts:true;mtype:6),
  (nom:'Dieu du mal';art:'un ';bf:300;bi:300;bd:300;adt:300;audt:300;
    sorts:true;mtype:6),
  (nom:'Monstre mtadivin';art:'un ';bf:500;bi:500;bd:500;
    adt:500;audt:500;sorts:true;mtype:4),
  (nom:'Garde royal';art:'un ';bf:5;bi:5;bd:5;adt:20;audt:20;
    sorts:false;mtype:7),
  (nom:'Roi Ergewin IV';art:'le ';bf:500;bi:1000;bd:500;adt:1500;audt:1500;
    sorts:true;mtype:7;gen:50000),
  (nom:'Serpent de mer';art:'un ';bf:20;bi:-10;bd:40;adt:30;audt:10;
    sorts:false;mtype:4),
  (nom:'Pieuvre gante';art:'un ';bf:50;bi:-5;bd:15;adt:20;audt:15;
    sorts:false;mtype:4),
  (nom:'Kraken';art:'un ';bf:100;bi:0;bd:10;adt:40;audt:100;
    sorts:false;mtype:4),
  (nom:'Dmiurge';art:'le ';bf:2000;bi:5000;bd:2000;adt:1000;audt:1000;
    sorts:true;mtype:5;gen:50000),
  (nom:'Turgath';art:'';bf:2000;bi:5000;bd:2000;adt:1000;audt:1000;
    sorts:true;mtype:6),
  (nom:'Roi de l''enfer';art:'le ';bf:500;bi:1000;bd:500;adt:1500;audt:1500;
    sorts:true;mtype:255));
  micones : array[1..nbmonstres] of byte =
  (27,60,29,29,30,31,29,32,33,34,35,36,37,38,39,32,40,41,
  62,63,64,65,28,26,76,77,78,79,80,81,82,87);
  mattr : array[1..nbmonstres] of byte =
  ($6F,$6A,$67,$67,$62,$68,$62,$60,$2A,$6E,$78,$64,$2A,$7A,$76,$70,
  $07,$4C,$06,$01,$04,$0C,$0F,$70,$1F,$1C,$12,$18,$17,$7E,$40,$1C);
  commavcom : array[1..nbmonstres] of string[30] =
  ('A l''attaque!','Taau!','Eh! Mais tu me cherches!',
  'Rrraa!!','Grrr...','Waouuuuu!?!','Gnneu...?','Houuu...hou?!',
  'Crroa,crrrrroaaa!','Bzzzzz...','Grrrgrrr!!!','...',
  'Kkkkccclc!','Hum, quel met raffin!','Tagada tagada',
  'Que vois-je?','Un missaire du Bien! Sus!','Flap flap flam flam...',
  'Bbbgrrrrooouuu','Zchschszzszch','Sus!','Hahaha ha ha haha...',
  'TU ES MORT!','Hahaha!','Aux armes!','A la garde!','Sss...flshh..',
  'Plsh..','Pllssh..Klack....Pllssh','Trahison!','Comme c''est spirituel!',
  '...');
  commgagne : array[1..nbmonstres] of string[30] =
  ('Dommage!','Rat!','Mme pas mal!','Ha!','Ho!',
  'Waouaouaou!','A ct!','Pas boum!','Croaa!','Picpique!','Miam!',
  'Piquepiquepic!!','Clqclqqkcclqk!','Mais tu me cherches?',
  'HAN!','LOUPE!','Minable!','Flap Flam...','Grrroaaaa!',
  'Sch! sch! sch!','Ho!','Ha ha ha! Ha!','Normal!','Pfff!','Je te tiens!',
  'Brigand!','SssSSousssouSSSSS','Plaksh!','Krack!',
  'Je t''avais fait confiance...','Quel dommage!','...');
  commperd : array[1..nbmonstres] of string[30] =
  ('Ae!','Oue!','Oe!','Ouch!','Vouaouf!',
  'Aaargh!','Aaaaahh!','Boum!','Flutch...!?','Kouic!',
  'Aoufff!?','Crrrack?','Clkclac?','Mon pied!','Maman!!! Au secours!',
  'Graimph!','Ha!','Grrrr!','Grraaaa!','Zzhhhai!','Ah!','Oh!','Quoi???',
  'Comment???','A la garde!','Gardes!','sss...','Floutch!','Flatch!',
  'Bonne chance pour la vie...','J''aurai ma revanche!','...');
  classes : array[1..3] of string[30] = ('Guerrier','Magicien','Voleur');
  singul : array[0..63] of string[30] =
  ('Un repas','Une potion','Un livre',
  'Une baguette','Un anneau',
  'L''Orbe du Soleil','L''Orbe de la Lune',
  'L''Orbe de l''Eau','L''Orbe du Feu','L''Orbe de la Terre',
  'L''Orbe de l''Air','L''Orbe de l''Univers Cleste','Une Clef en or',
  '','','','','','','','','','','','','','','','','','','','',
  'Une pe','Une pe  deux mains','Une hache','Un arc',
  'Une Relique (arme)','','','','','','','','','','','',
  'Une cotte de mailles','Une armure plate','Un haume','Un bouclier',
  'Une Relique (armure)','','','','','','','','','','');
  pluriel : array[0..63] of string[30] =
  ('repas','potions','',
  '','','','','','','','','','','','','',
  '','','','','','','','','','','','','','','','','',
  '','','','','','','','','','',
  '','','','','','','','','','',
  '','','','','','','','','','','');
  potsg : array[0..15] of string[20] = ('bleue','rouge','jaune',
  'orange','verte','noire','blanche','transparente','mauve',
  'sienne','cladon','opale','meraude','rubis','saphir',
  'diamant');
  potpl : array[0..15] of string[20] = ('bleues','rouges','jaunes',
  'orange','vertes','noires','blanches','transparentes','mauves',
  'sienne','cladon','opale','meraude','rubis','saphir',
  'diamant');
  potprx : array[0..15] of longint = (1,5,6,3,3,4,20,25,10,25,
  30,40,50,75,100,200);
  annx : array[0..15] of string[20] = ('de bois','de pierre','de fer',
  'de cuivre','d''argent','d''or','de platine','d''meraude','de rubis',
  'de saphir','de diamant','d''toile','de lumire','de Temps',
  'de Vie','de l''Infini');
  annprx : array[0..15] of longint = (10,15,5,100,100,100,200,500,500,500,
  1000,2000,5000,10000,20000,50000);
  bagts : array[0..15] of string[20] = ('de pierre','de sapin','de platane',
  'de chne','d''bne','de fer','de cuivre','d''argent','d''or',
  'de platine','d''meraude','de rubis','de saphir','de diamant',
  'de lumire','de l''Infini');
  bagprx : array[0..15] of longint = (10,15,5,100,100,100,200,500,500,500,
  1000,2000,5000,10000,20000,50000);
  tmplnom : array[5..11] of string[30] = ('du soleil','de la lune',
  'de l''eau','du feu','de la terre','de l''air','de l''Univers Cleste');
  mantras : array[5..11] of string[10] = ('RA','NU','PLO','PYR','GE','AHM',
  'OM');
  parties : array[32..63] of set of byte =
  ([],[9],[9,10],[9],[9,10],[9,10],[],[],[],[],[],[],[],[],[],[],
  [],[2],[0,2,3,4,5,6,7,8,14,15,16,17,18,19],[0],[10],
  [0,1,2,3,4,5,6,7,8,13,14,15,16,17,18,19],[],[],[],[],[],[],[],[],[],[]);
  {0=tte   1=cou   2=corps
  3=bras droit 4=bras gauche
  5=avant-bras droit 6=avant-bras gauche
  7=poignet droit 8=poignet gauche
  9=main droite 10=pied gauche
  11=annulaire droit 12=annulaire gauche
  13=ceinture
  14=jambe droite 15=jambe gauche
  16=poignet droit 17=poignet gauche
  18=pied droit 19=pied gauche}
  prix : array[0..31] of longint =
  (0,2,150,1600,1400,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
  jours : array[0..6] of string[30] =
  ('Anergedi','Laurendi','Philidi','Davidi','Dmiurdi','Maudi','Pantodies');
  vents : array[0..7] of string[30] =
  ('S','SW','W','NW','N','NE','E','SE');

type
  sndbuftype = array[0..32767] of byte;
  instrstype = array[0..256] of record
    pm,pc,vm,vc,rm,rc,sm,sc,wm,wc,fm,ex1,ex2,ex3,ex4,ex5 : byte;
  end;
  egapalette = array[0..16] of byte;
  vgapalette = array[0..15] of record r,g,b : byte; end;
  byteset = set of byte;

const
  provga : egapalette = ($00,$01,$02,$03,$04,$05,$06,$07,
    $08,$09,$0A,$0B,$0C,$0D,$0E,$0F,$00);
  stdvga : vgapalette = ((r:0;g:0;b:0),(r:0;g:0;b:42),(r:0;g:42;b:0),
    (r:0;g:42;b:42),(r:42;g:0;b:0),(r:42;g:0;b:42),(r:42;g:21;b:0),
    (r:42;g:42;b:42),(r:21;g:21;b:21),(r:21;g:21;b:63),(r:21;g:63;b:21),
    (r:21;g:63;b:63),(r:63;g:21;b:21),(r:63;g:21;b:63),(r:63;g:63;b:21),
    (r:63;g:63;b:63));
  jour : vgapalette = ((r:3;g:3;b:3),(r:7;g:7;b:47),(r:0;g:47;b:15),
    (r:7;g:31;b:47),(r:47;g:0;b:7),(r:31;g:0;b:47),(r:47;g:23;b:3),
    (r:47;g:47;b:47),(r:31;g:31;b:31),(r:0;g:15;b:63),(r:0;g:63;b:15),
    (r:15;g:39;b:63),(r:63;g:0;b:9),(r:47;g:0;b:63),(r:63;g:63;b:15),
    (r:63;g:63;b:63));
  nuit : vgapalette = ((r:0;g:0;b:0),(r:3;g:3;b:31),(r:0;g:31;b:15),
    (r:3;g:15;b:31),(r:31;g:0;b:7),(r:15;g:0;b:31),(r:21;g:10;b:0),
    (r:31;g:31;b:31),(r:15;g:15;b:15),(r:0;g:7;b:47),(r:0;g:47;b:15),
    (r:7;g:21;b:47),(r:47;g:0;b:9),(r:31;g:0;b:47),(r:31;g:47;b:15),
    (r:47;g:47;b:47));
  matin : vgapalette = ((r:2;g:2;b:1),(r:7;g:0;b:41),(r:7;g:41;b:7),
    (r:7;g:39;b:39),(r:41;g:7;b:7),(r:39;g:3;b:39),(r:41;g:24;b:10),
    (r:41;g:41;b:41),(r:27;g:27;b:27),(r:7;g:7;b:55),(r:15;g:55;b:15),
    (r:15;g:51;b:51),(r:55;g:9;b:9),(r:51;g:5;b:51),(r:57;g:57;b:11),
    (r:59;g:59;b:59));
  soir : vgapalette = ((r:3;g:1;b:1),(r:15;g:0;b:37),(r:7;g:37;b:7),
    (r:11;g:27;b:37),(r:42;g:0;b:5),(r:42;g:0;b:37),(r:42;g:13;b:0),
    (r:42;g:37;b:43),(r:27;g:21;b:21),(r:7;g:7;b:53),(r:7;g:53;b:7),
    (r:15;g:35;b:53),(r:57;g:0;b:9),(r:55;g:0;b:53),(r:57;g:51;b:15),
    (r:57;g:53;b:53));
  artificiel : vgapalette = ((r:5;g:5;b:5),(r:9;g:9;b:50),(r:0;g:50;b:19),
    (r:7;g:34;b:53),(r:50;g:0;b:10),(r:36;g:0;b:50),(r:50;g:26;b:5),
    (r:53;g:53;b:53),(r:33;g:33;b:33),(r:0;g:15;b:63),(r:0;g:63;b:15),
    (r:17;g:41;b:63),(r:63;g:0;b:11),(r:49;g:0;b:63),(r:63;g:63;b:15),
    (r:63;g:63;b:63));
  enfer : vgapalette = ((r:3;g:0;b:0),(r:10;g:3;b:31),(r:15;g:31;b:10),
    (r:7;g:15;b:25),(r:31;g:5;b:0),(r:31;g:0;b:20),(r:31;g:12;b:0),
    (r:38;g:31;b:31),(r:22;g:15;b:15),(r:14;g:7;b:47),(r:17;g:47;b:10),
    (r:10;g:21;b:41),(r:54;g:0;b:9),(r:47;g:0;b:35),(r:47;g:40;b:5),
    (r:53;g:47;b:47));
  stdega : egapalette = ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$39,$3A,$3B,$3C,$3D,$3E,$3F,$00);
  egapals : array[0..15] of egapalette = (($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$39,$3A,$3B,$3C,$3D,$3E,$3F,$00),
    ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$09,$12,$1B,$24,$2D,$36,$3F,$00),
    ($00,$08,$10,$18,$20,$28,$20,$38,
    $00,$01,$02,$03,$04,$05,$06,$07,$00),
    ($00,$09,$0A,$0B,$0C,$0D,$14,$0E,
    $38,$09,$1A,$1B,$2C,$2D,$3E,$3F,$00),
    ($00,$21,$22,$23,$24,$25,$14,$27,
    $38,$29,$32,$3B,$24,$2D,$36,$3F,$00),
    ($00,$31,$32,$33,$34,$35,$14,$37,
    $38,$39,$32,$3B,$34,$3D,$36,$3F,$00),
    ($00,$21,$22,$23,$24,$25,$14,$27,
    $38,$29,$32,$3B,$24,$2D,$36,$3F,$00),
    ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$09,$12,$1B,$24,$2D,$36,$3F,$00),
    ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$09,$12,$1B,$24,$2D,$36,$3F,$00),
    ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$09,$12,$1B,$24,$2D,$36,$3F,$00),
    ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$09,$12,$1B,$24,$2D,$36,$3F,$00),
    ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$09,$12,$1B,$24,$2D,$36,$3F,$00),
    ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$09,$12,$1B,$24,$2D,$36,$3F,$00),
    ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$09,$12,$1B,$24,$2D,$36,$3F,$00),
    ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$09,$12,$1B,$24,$2D,$36,$3F,$00),
    ($00,$01,$02,$03,$04,$05,$14,$07,
    $38,$09,$12,$1B,$24,$2D,$36,$3F,$00));

const
  ecrpiletaille = 1;

type
  mdtype = array[0..149] of ^ligne;
  ecrtype = array[1..25,1..80] of
    record ch : char; at : byte; end;
  ecrptype = record
    e : ecrtype;
    x,y,t : byte;
    _tmp : array[3..15] of byte;
  end;

var
  per : personnage;
  adv : personnage;
  i,j,k,l,m,n,o,p : longint;
  b1,b2,b3,b4 : boolean;
  t1,t2,t3,t4 : byte;
  s,s2,s3 : string;
  real1,real2 : real;
  tmp : integer;
  tmpleno : byte;
  villenom : string;
  villepop : longint;
  tombes : array[5..11] of boolean;
  maxgain : word;
  c,c2 : char;
  tim,dat,mutim,mutim2 : longint;
  dis : integer;
  vdir,vfor : shortint;
  monde,mondeo : mdtype;
  md : ^mdtype;
  ecran : ecrtype absolute $B800:$0000;
  ecrpile : array[1..ecrpiletaille] of ^ecrptype;
  ecrpileptr : byte;
  cv : array[0..255] of char;
  posx,posy,posxo,posyo,dirx,diry,direc : integer;
  demix,demiy : longint;
  io : integer;
  skey : char;
  memneeded : longint;
  tempspasse,riendutout,abouge,xcombat : boolean;
  regs : registers;
  smode,shows,gmode,showg,loaded,quit,dansmu,jetdesorts,carteok : boolean;
  vmode,showv,plein,bw : boolean;
  connait_code : boolean;
  lb : byte;
  trich_montr : boolean;
  f : file;
  configf : file;
  select : byte;
  mondeno : byte;
  danschat : boolean;
  aleateur : longint;
  timer : longint absolute $0040:$006C;
  time1,time2 : longint;
  nosvga,nohi,nopal,novga,noega,nosnd,nosb,usepc,novoc,noemsovr : boolean;
  music,sndloaded : boolean;
  sbregs : array[0..255] of byte;
  sndtrk,sndend : array[0..31] of word;
  snddels : array[0..31] of longint;
  sndcom : array[0..31] of byte;
  sndchvol,sndntvol : array[0..15] of byte;
  sndins : array[0..15] of integer;
  musvol : integer;
  instrs : ^instrstype;
  dtime : word;
  tempo : longint;
  midispeed : longint;
  voice : byte;
  sndcnt,sndlen : word;
  sndbuf : ^sndbuftype;
  sndf,insf : file;
  sbpresent,sb : boolean;
  colcnt : word;
  dernieres : array[0..7] of record r,g,b : byte; end;
  curpal : byte;
  oldtimer : procedure;
  clkval,clkcount : longint;
  fontf : file;
  fontloaded : boolean;
  vocport,vocirq,vocdma : word;
  vocpro : boolean;
  ctf,vocf : file;
  ctpointer,ctptr : pointer;
  ctsize : longint;
  ctstatus : word;
  ctok,vocok : boolean;
  code : string;
  bios,bios2 : array[0..255] of byte;
  vieilarme : record
    tipe : byte;
    portee : boolean;
    maudite : boolean;
    bonfrc,bonint,bondex : integer;
    dommages : integer;
  end;

type
  smallblock = array[0..7,0..7] of byte;
  bigblock = array[0..15,0..15] of byte;
  smallsblock = array[0..15,0..15] of byte;
  bigsblock = array[0..31,0..31] of byte;
  block = record
    s : smallblock;
    b : bigblock;
  end;
  sblockdata = record
    s : smallsblock;
    b : bigsblock;
  end;
  sblock = ^sblockdata;
  fonttype = array[0..255,0..15] of byte;
  dessin = array[0..15] of byte;
  vocdatatype = array[0..65519] of byte;
  vocdataptr = ^vocdatatype;

var
  gblk : array[0..nbicos-1] of block;
  sblk : array[0..nbicos-1] of sblock;
  font : fonttype;
  vocp : vocdataptr;
  pnjs : array[1..20,0..7] of byte;

const
  nomjeu = 'LEGENDES I';
  verstr = 'VERSION 21.26 SPECIALE';
  vermaj = 21;
  vermin = 2;
  verbog = 6;
  compat = 35;
  mincompat = 12;

implementation

end.
