procedure faismonde;

const
  tempos : array[0..8] of record
    num,fnd : byte;
    x,y : integer;
  end = ((num:12;fnd:16;x:0;y:0),
  (num:5;fnd:13;x:75;y:0),
  (num:6;fnd:13;x:75;y:149),
  (num:7;fnd:13;x:0;y:149),
  (num:8;fnd:13;x:149;y:0),
  (num:9;fnd:13;x:149;y:75),
  (num:10;fnd:13;x:0;y:75),
  (num:11;fnd:13;x:75;y:75),
  (num:0;fnd:13;x:149;y:149));

var
  wx,wy : longint;
  portx,porty : longint;
  routesok : boolean;

label
  restart;

procedure faislac(cx,cy : longint;r,mat : byte);
begin
  for l := -5 to 5 do for m := -5 to 5 do
    if sqr(l)+sqr(m)+random(10)<r then begin
      if (cx+l>=0) and (cx+l<150) and (cy+m>=0) and (cy+m<150) then
        monde[cx+l]^[cy+m].a := mat;
    end;
end;

procedure road(dx,dy,ax,ay : longint;mat : byte;inter : byteset);
procedure decx;
begin
  if (wx>0) and (not (monde[wx-1]^[wy].a in inter)) then dec(wx);
end;
procedure incx;
begin
  if (wx<149) and (not (monde[wx+1]^[wy].a in inter)) then inc(wx);
end;
procedure decy;
begin
  if (wy>0) and (not (monde[wx]^[wy-1].a in inter)) then dec(wy);
end;
procedure incy;
begin
  if (wy<149) and (not (monde[wx]^[wy+1].a in inter)) then inc(wy);
end;
begin
  if not routesok then exit;
  wx := dx;
  wy := dy;
  repeat
    i := random(8);
    case i of
      0,1 : if wx<ax then incx else if wx>ax then decx;
      2,3 : if wy<ay then incy else if wy>ay then decy;
      4 : decx;
      5 : incx;
      6 : decy;
      7 : incy;
    end;
    monde[wx]^[wy].a := mat;
    if timer>time1+300 then begin
      writeln('...echec.');
      routesok := false;
      exit;
    end;
  until (wx=ax) and (wy=ay);
end;

begin
  randseed := aleateur;
  quit := false;
  restart:
  writeln('Initialisation du monde...');
  for i := 0 to 149 do for j := 0 to 149 do begin
    monde[i]^[j].a := 1;
    monde[i]^[j].b := 0;
  end;
  writeln('Placement des forts...');
  for i := 0 to 149 do for j := 0 to 149 do
    if random<0.15 then begin
      monde[i]^[j].a := 2;
      if i>0 then monde[i-1]^[j].a := 2;
      if i<149 then monde[i+1]^[j].a := 2;
      if j>0 then monde[i]^[j-1].a := 2;
      if j<149 then monde[i]^[j+1].a := 2;
    end;
  writeln('Calcul de la mer...');
  k := 110;
  for i := 0 to 149 do begin
    if k<80 then k := 80;
    for j := k to 149 do monde[i]^[j].a := 0;
    if i=75 then begin
      portx := 75;
      porty := k;
    end;
    l := random(6)+i div 40;
    inc(k,l-3);
  end;
  writeln('Positionnement des montagnes...');
  for i := 0 to 149 do for j := 0 to 149 do begin
    m := j+150-i;
    if random(120)>m then monde[i]^[j].a := 3;
  end;
  writeln('Remplissage des lacs...');
  faislac(19,37,25,0);
  faislac(56,56,25,0);
  for k := 1 to random(9)+4 do
    faislac(random(140)+5,random(140)+5,random(20)+5,0);
  faislac(75,149,30,12);
  faislac(30,120,30,14);
  writeln('Trac des routes...');
  monde[portx]^[porty].a := 13;
  monde[portx+1]^[porty].a := 13;
  time1 := timer;
  routesok := true;
  road(149,149,portx,porty,4,[0]);
  road(portx,porty,75,75,4,[0]);
  road(37,75,0,148,0,[4]);
  road(19,37,37,75,0,[4]);
  road(56,56,37,75,0,[4]);
  road(75,75,149,0,1,[0]);
  road(75,75,75,0,1,[0]);
  road(75,75,149,75,1,[0]);
  road(75,75,60,80,4,[]);
  if not routesok then goto restart;
  for i := 0 to 8 do begin
    monde[tempos[i].x]^[tempos[i].y].a := tempos[i].fnd;
    monde[tempos[i].x]^[tempos[i].y].b := tempos[i].num;
  end;
  repeat
    demix := random(150);
    demiy := random(150);
  until (monde[demix]^[demiy].b=0) and (monde[demix]^[demiy].a>=1)
    and (monde[demix]^[demiy].a<=3) and (sqr(150-demix)+sqr(150-demiy)>5625)
    and (sqr(75-demix)+sqr(75-demix)>2500);
  monde[demix]^[demiy].a := 13;
  monde[demix]^[demiy].b := 1;
  writeln('Fixation des villages et trsors...');
  for i := 0 to 149 do for j := 0 to 149 do
    if (monde[i]^[j].b=0) then begin
      if (random(20)<16) or ((monde[i]^[j].a<>1) and (monde[i]^[j].a<>2))
        then {}
      else if random(10)=0 then monde[i]^[j].b := 2
      else if random(15)=0 then monde[i]^[j].b := 4;
    end;
  monde[148]^[149].a := 13;
  monde[149]^[149].a := 13;
  monde[148]^[149].b := 76;
  monde[149]^[149].b := 77;
  monde[portx]^[porty].a := 13;
  monde[portx+1]^[porty].a := 13;
  monde[portx]^[porty].b := 76;
  monde[portx+1]^[porty].b := 77;
  monde[portx]^[porty+1].b := 78;
  for i := 57 to 63 do for j := 77 to 83 do begin
    monde[i]^[j].a := 13;
    monde[i]^[j].b := 0;
  end;
  monde[60]^[79].b := 73;
  monde[60]^[80].b := 76;
  monde[61]^[80].b := 77;
  monde[30]^[120].a := 13;
  monde[30]^[120].b := 80;
  writeln('Dtermination des cratures...');
  writeln('0   25   50   75  100%');
  writeln('|    |    |    |    |');
  for i := 0 to 149 do begin
   gotoxy(1,wherey);
   for k := 0 to i*20 div 150+1 do write(#219);
   for j := 0 to 149 do begin
    if (monde[i]^[j].b=0) and (monde[i]^[j].a<>0)
    and (monde[i]^[j].a<>3) and (monde[i]^[j].a<>13)
    and (monde[i]^[j].a<>14) and (monde[i]^[j].a<>12) then begin
      if 2*longint(random(30000))<150-abs(i-150)-abs(j-150)
        then monde[i]^[j].b := 13;
      if 2*longint(random(30000))<150-abs(i-75)-abs(j-100)
        then monde[i]^[j].b := 14;
      if 2*longint(random(30000))<150-abs(i-120)-abs(j-30)
        then monde[i]^[j].b := 15;
      if 2*longint(random(30000))<150-abs(i-60)-abs(j-0)
        then monde[i]^[j].b := 16;
      if 2*longint(random(30000))<150-abs(i-70)-abs(j-0)
        then monde[i]^[j].b := 17;
      if 2*longint(random(30000))<150-abs(i-75)-abs(j-75)
        then monde[i]^[j].b := 18;
      if 2*longint(random(30000))<150-abs(i-150)-abs(j-50)
        then monde[i]^[j].b := 19;
      if 2*longint(random(35000))<150-abs(i-60)-abs(j-60)
        then monde[i]^[j].b := 20;
      if 2*longint(random(20000))<150-abs(i-125)-abs(j-100)
        then monde[i]^[j].b := 21;
      if 2*longint(random(20000))<150-abs(i-100)-abs(j-100)
        then monde[i]^[j].b := 22;
      if 2*longint(random(20000))<150-abs(i-75)-abs(j-75)
        then monde[i]^[j].b := 23;
      if 2*longint(random(20000))<150-abs(i-100)-abs(j-50)
        then monde[i]^[j].b := 24;
      if 2*longint(random(20000))<150-abs(i-100)-abs(j-100)
        then monde[i]^[j].b := 25;
      if 2*longint(random(40000))<150-abs(i-150)-abs(j-0)
        then monde[i]^[j].b := 26;
      if 2*longint(random(40000))<150-abs(i-0)-abs(j-100)
        then monde[i]^[j].b := 27;
      if 2*longint(random(40000))<150-abs(i-100)-abs(j-50)
        then monde[i]^[j].b := 28;
      if (abs(i-0)+abs(j-0)<20) and (random(5)=0)
        then monde[i]^[j].b := 29;
      if (abs(i-demix)+abs(j-demiy)<10) and (random(5)=0)
        then monde[i]^[j].b := 29;
      if 2*longint(random(50000))<150-abs(i-149)-abs(j-0)
        then monde[i]^[j].b := 30;
    end;
    if (monde[i]^[j].b=0) and (monde[i]^[j].a=0) then begin
      if 2*longint(random(30000))<150-abs(i-40)-abs(j-90)
        then monde[i]^[j].b := 39;
      if 2*longint(random(30000))<150-abs(i-30)-abs(j-125)
        then monde[i]^[j].b := 40;
      if 2*longint(random(30000))<150-abs(i-0)-abs(j-150)
        then monde[i]^[j].b := 41;
    end;
   end;
  end;
  writeln;
  writeln('Malfication...');
  for i := 0 to 10 do for j := 0 to 10 do
    if i*i+j*j<=100 then malef(i,j);
  mondeno := 0;
  danschat := false;
  vdir := random(8);
  vfor := random(12);
end;