procedure graphmode;
begin
  if gmode then exit;
  gmode := true;
  vmode := false;
  smode := false;
  regs.ax := $0010;
  intr($10,regs);
  grzedessins;
  if not novga then begin
    preparevgapalettes;
    selectpalette(curpal,true);
  end else if not noega then selectpalette(curpal,true);
  carteok := false;
end;

procedure supermode;
begin
  if smode then exit;
  smode := true;
  gmode := false;
  vmode := false;
  regs.ax := $005E;
  intr($10,regs);
  dernpal;
  grzedessins;
  carteok := false;
end;

procedure vgamode;
begin
  if vmode then exit;
  vmode := true;
  gmode := false;
  smode := false;
  regs.ax := $0013;
  intr($10,regs);
  dernpal;
  grzedessins;
end;

procedure dernpal;
var
  inregs : registers;
begin
  inregs.ax := $1012;
  inregs.bx := 248;
  inregs.cx := 8;
  inregs.es := seg(dernieres);
  inregs.dx := ofs(dernieres);
  intr($10,inregs);
end;

{$F+}

{$L PUTDOT}

{$L PUTBLOCK}

{$L PUTBIG}

{$L PUTBAR}

procedure putdot(x,y : word;c : byte);
external;

procedure putblock(x,y : word;var blk : block);
external;

procedure putbigblock(x,y : word;var blk : block);
external;

procedure putbar(y,l : word;c : byte);
external;

{$F-}

procedure putsdot(x,y : longint;c : byte);
var
  lin,a,b : longint;
begin
  lin := x+y*800;
  a := lin and 65535;
  b := lin shr 16;
  b := b xor 2;
  if b<>lb then begin
    port[$3C4] := $0E;
    port[$3C5] := b;
  end;
  mem[$A000:a] := c;
  lb := b;
end;

procedure putsblock(x,y : word;blk : sblock);
var
  i,j : word;
begin
  for i := 0 to 15 do for j := 0 to 15 do
    if blk^.s[j,i]<>16 then putsdot(i+x,j+y,blk^.s[j,i]);
end;

procedure putsbigblock(x,y : word;blk : sblock);
var
  i,j : word;
begin
  for i := 0 to 31 do for j := 0 to 31 do
    if blk^.b[j,i]<>16 then putsdot(i+x,j+y,blk^.b[j,i]);
end;

procedure putsbar(y,l : word;c : byte);
var
  i : word;
begin
  for i := 0 to l do putsdot(i,y,c);
end;

procedure putvdot(x,y : longint;c : byte);
begin
  mem[$A000:x+y*320] := c;
end;

procedure putvgablock(x,y : word;blk : sblock);
var
  i,j : word;
begin
  for i := 0 to 15 do for j := 0 to 15 do
    if blk^.s[j,i]<>16 then putvdot(i+x,j+y,blk^.s[j,i]);
end;

procedure clrscr;
var
  t : byte;
begin
  t := textattr;
  if gmode or smode or vmode then begin
    textmode(co80);
    if not noega then fondbrillant;
    if not novga then begin
      preparevgapalettes;
      selectpalette(curpal,true);
    end else if not noega then selectpalette(curpal,true);
    if not noega then zedessins;
  end;
  gmode := false;
  smode := false;
  vmode := false;
  textattr := t;
  crt.clrscr;
end;