program iconsedit;

uses
  dos,
  crt;

const
  nmodes = 11;

type
  small = array[0..15,0..15] of byte;
  big = array[0..31,0..31] of byte;
  lowsmall = array[0..7,0..7] of byte;
  lowbig = array[0..15,0..15] of byte;
  block = array[0..3] of big;

const
  side : array[0..3] of byte = (16,32,8,16);
  mf : array[1..nmodes,0..3] of longint =
  ((2,1,4,2),(3,2,6,3),(4,2,8,4),(1,1,2,1),(2,1,4,2),(3,2,6,3),(4,2,8,4),
  (2,1,4,2),(3,2,6,3),(4,2,8,4),(4,4,4,4));
  vmodes : array[1..nmodes] of byte =
  ($10,$10,$10,$13,$13,$13,$13,$5E,$5E,$5E,$5E);

var
  regs : registers;
  f : file of small;
  g : file of big;
  lf : file of lowsmall;
  lg : file of lowbig;
  it : block;
  s : small;
  b : big;
  lws : lowsmall;
  lwb : lowbig;
  n : byte;
  i,j,k,l,m,m1x,m1y,m2x,m2y : longint;
  c : char;
  couleur,oldcol : byte;
  size,ns : byte;
  lb : byte;
  mode : byte;

procedure putsvgadot(x,y : longint;c : byte);
var
  lin,a,b : longint;
begin
  lin := x+y*800;
  a := lin and 65535;
  b := lin shr 16;
  b := b xor 2;
  if b<>lb then begin
    port[$3C4] := $0E;
    port[$3C5] := b;
  end;
  mem[$A000:a] := c;
  lb := b;
end;

procedure putvgadot(x,y : longint;c : byte);
begin
  mem[$A000:x+y*320] := c;
end;

{$F+}
{$L PUTDOT}
procedure putdot(x,y : word;c : byte);
external;
{$F-}

procedure put_dot(x,y : longint;c : byte);
begin
  case mode of
    1,2,3 : putdot(x,y,c and 15);
    4,5,6,7 : putvgadot(x,y,c);
    8,9,10,11 : putsvgadot(x,y,c);
  end;
end;

procedure setmode;
begin
  regs.ah := $00;
  regs.al := vmodes[mode];
  intr($10,regs);
  lb := 255;
end;

procedure colorbar;
var
  k,l : word;
begin
  case mode of
    1,2,3 : for k := 0 to 63 do for l := 0 to 4 do
      putdot(k,200+l,k div 4);
    4,5,6,7 : for k := 0 to 255 do for l := 0 to 4 do
      putvgadot(k,150+l,k);
    8,9,10,11 : for k := 0 to 511 do for l := 0 to 4 do
      putsvgadot(k,200+l,k div 2);
  end;
end;

procedure cursor;
begin
  case mode of
    1,2,3 : begin
      for k := 0 to 5 do putdot((oldcol and 15)*4+2,205+k,0);
      for k := 0 to 5 do putdot((couleur and 15)*4+2,205+k,15);
    end;
    4,5,6,7 : begin
      for k := 0 to 5 do putvgadot(oldcol,155+k,0);
      for k := 0 to 5 do putvgadot(couleur,155+k,15);
    end;
    8,9,10,11 : begin
      for k := 0 to 5 do putsvgadot(oldcol*2,205+k,0);
      for k := 0 to 5 do putsvgadot(couleur*2,205+k,15);
    end;
  end;
end;

procedure putit(var b : block;n : byte);
var
  k,l : word;
  x,y : word;
begin
  for k := 0 to side[n]-1 do for l := 0 to side[n]-1 do begin
    for x := l*mf[mode,size] to l*mf[mode,size]+mf[mode,size]-1 do
    for y := k*mf[mode,size] to k*mf[mode,size]+mf[mode,size]-1 do
      if b[n,k,l]<>16 then
        put_dot(x,y,b[n,k,l])
      else put_dot(x,y,(x+y) shr 1 and 1 * 15);
    if (k=i) and (l=j) then begin
      for x := l*mf[mode,size] to l*mf[mode,size]+mf[mode,size]-1 do begin
        put_dot(x,k*mf[mode,size],15);
        put_dot(x,k*mf[mode,size]+mf[mode,size]-1,14);
      end;
      for y := k*mf[mode,size] to k*mf[mode,size]+mf[mode,size]-1 do begin
        put_dot(l*mf[mode,size],y,13);
        put_dot(l*mf[mode,size]+mf[mode,size]-1,y,12);
      end;
    end;
  end;
  for k := 0 to side[n]-1 do for l := 0 to side[n]-1 do
    if b[n,k,l]<>16 then
      put_dot(l+192,k,b[n,k,l])
    else put_dot(l+192,k,0);
  for k := 0 to side[n]-1 do for l := 0 to side[n]-1 do
    if b[n,k,l]<>16 then
      put_dot(l+224,k,b[n,k,l])
    else put_dot(l+224,k,15);
  if couleur<>16 then
    for k := 0 to 15 do for l := 0 to 15 do put_dot(l+256,k,couleur)
  else for k := 0 to 15 do for l := 0 to 15 do
    put_dot(l+256,k,(k+l) shr 1 and 1 * 15);
  cursor;
end;

procedure readit(var bl : block;n : byte);
var
  _i,_j : byte;
begin
  seek(f,n);
  read(f,s);
  seek(g,n);
  read(g,b);
  seek(lf,n);
  read(lf,lws);
  seek(lg,n);
  read(lg,lwb);
  for _i := 0 to 15 do for _j := 0 to 15 do bl[0,_i,_j] := s[_i,_j];
  for _i := 0 to 31 do for _j := 0 to 31 do bl[1,_i,_j] := b[_i,_j];
  for _i := 0 to 7 do for _j := 0 to 7 do bl[2,_i,_j] := lws[_i,_j];
  for _i := 0 to 15 do for _j := 0 to 15 do bl[3,_i,_j] := lwb[_i,_j];
end;

procedure writeit(var bl : block;n : byte);
var
  _i,_j : byte;
begin
  for _i := 0 to 15 do for _j := 0 to 15 do s[_i,_j] := bl[0,_i,_j];
  for _i := 0 to 31 do for _j := 0 to 31 do b[_i,_j] := bl[1,_i,_j];
  for _i := 0 to 7 do for _j := 0 to 7 do lws[_i,_j] := bl[2,_i,_j];
  for _i := 0 to 15 do for _j := 0 to 15 do lwb[_i,_j] := bl[3,_i,_j];
  seek(f,n);
  write(f,s);
  seek(g,n);
  write(g,b);
  seek(lf,n);
  write(lf,lws);
  seek(lg,n);
  write(lg,lwb);
end;

begin
  n := 0;
  i := 0;
  j := 0;
  m1x := 0;
  m1y := 0;
  m2x := 31;
  m2y := 31;
  couleur := 0;
  oldcol := 255;
  mode := 1;
  assign(f,'SSMALL.ICO');
  reset(f);
  assign(g,'SBIG.ICO');
  reset(g);
  assign(lf,'SMALL.ICO');
  reset(lf);
  assign(lg,'BIG.ICO');
  reset(lg);
  readit(it,n);
  size := 0;
  setmode;
  colorbar;
  repeat
    putit(it,size);
    c := readkey;
    c := upcase(c);
    case c of
      #27 : begin
        textmode(co80);
        halt;
      end;
      #13 : it[size,i,j] := couleur;
      ^I : begin
        textattr := $00;
        clrscr;
        lb := 255;
        ns := (size+1) and 3;
        i := i*side[ns] div side[size];
        j := j*side[ns] div side[size];
        m1x := m1x*side[ns] div side[size];
        m1y := m1y*side[ns] div side[size];
        m2x := m2x*side[ns] div side[size];
        m2y := m2y*side[ns] div side[size];
        size := ns;
        colorbar;
      end;
      'S' : writeit(it,n);
      'C' : for k := 0 to 31 do for l := 0 to 31 do it[size,k,l] := couleur;
      '+' : writeit(it,filesize(f));
      '[' : begin
        m1x := i;
        m1y := j;
      end;
      ']' : begin
        m2x := i;
        m2y := j;
      end;
      '<' : if mode>1 then begin
        dec(mode);
        setmode;
        colorbar;
      end;
      '>' : if mode<nmodes then begin
        inc(mode);
        setmode;
        colorbar;
      end;
      'F' : begin
        for k := m1x to m2x do for l := m1y to m2y do
          it[size,k,l] := couleur;
      end;
      '1'..'4' : begin
        ns := byte(c)-49;
        for k := 0 to 31 do for l := 0 to 31 do
          it[size,k*side[size] div 32,l*side[size] div 32] :=
          it[ns,k*side[ns] div 32,l*side[ns] div 32];
      end;
      'R' : begin
        m := it[size,i,j];
        for k := 0 to 31 do for l := 0 to 31 do
          if it[size,k,l]=m then it[size,k,l] := couleur;
      end;
      #00 : begin
        c := readkey;
        case c of
          #15 : begin
            textattr := $00;
            clrscr;
            lb := 255;
            ns := (size-1) and 3;
            i := i*side[ns] div side[size];
            j := j*side[ns] div side[size];
            m1x := m1x*side[ns] div side[size];
            m1y := m1y*side[ns] div side[size];
            m2x := m2x*side[ns] div side[size];
            m2y := m2y*side[ns] div side[size];
            size := ns;
            colorbar;
          end;
          #73 : if n>0 then begin
            dec(n);
            readit(it,n);
          end;
          #81 : if n<filesize(f)-1 then begin
            inc(n);
            readit(it,n);
          end;
          #72 : i := (i+side[size]-1) mod side[size];
          #75 : j := (j+side[size]-1) mod side[size];
          #77 : j := (j+1) mod side[size];
          #80 : i := (i+1) mod side[size];
          #59 : begin
            oldcol := couleur;
            couleur := couleur xor 1;
          end;
          #60 : begin
            oldcol := couleur;
            couleur := couleur xor 2;
          end;
          #61 : begin
            oldcol := couleur;
            couleur := couleur xor 4;
          end;
          #62 : begin
            oldcol := couleur;
            couleur := couleur xor 8;
          end;
          #63 : begin
            oldcol := couleur;
            couleur := couleur xor 16;
          end;
          #64 : begin
            oldcol := couleur;
            couleur := couleur xor 32;
          end;
          #65 : begin
            oldcol := couleur;
            couleur := couleur xor 64;
          end;
          #66 : begin
            oldcol := couleur;
            couleur := couleur xor 128;
          end;
          #67 : begin
            oldcol := couleur;
            couleur := 0;
          end;
          #68 : begin
            oldcol := couleur;
            couleur := 16;
          end;
          #84..#93 : begin
            oldcol := couleur;
            couleur := byte(c)-84;
          end;
          #94 : begin
            oldcol := couleur;
            dec(couleur,1);
          end;
          #95 : begin
            oldcol := couleur;
            inc(couleur,1);
          end;
          #96 : begin
            oldcol := couleur;
            dec(couleur,4);
          end;
          #97 : begin
            oldcol := couleur;
            inc(couleur,4);
          end;
          #98 : begin
            oldcol := couleur;
            dec(couleur,16);
          end;
          #99 : begin
            oldcol := couleur;
            inc(couleur,16);
          end;
          #100 : begin
            oldcol := couleur;
            dec(couleur,64);
          end;
          #101 : begin
            oldcol := couleur;
            inc(couleur,64);
          end;
          #102 : begin
            oldcol := couleur;
            couleur := it[size,i,j];
          end;
          #103 : begin
            k := oldcol;
            oldcol := couleur;
            couleur := k;
          end;
        end;
      end;
    end;
  until false;
end.