procedure sbputout(reg,dat : byte);
var
  _ : word;
begin
  port[$388] := reg;
  for _ := 1 to 100 do;
  port[$389] := dat;
  for _ := 1 to 1000 do;
  sbregs[reg] := dat;
end;

const
  vtab : array[0..8] of record m,p : byte; end
  = ((m:$00;p:$03),(m:$01;p:$04),(m:$02;p:$05),
  (m:$08;p:$0B),(m:$09;p:$0C),(m:$0A;p:$0D),
  (m:$10;p:$13),(m:$11;p:$14),(m:$12;p:$15));
  notetab : array[0..11] of word
  = (343,363,385,408,432,458,485,514,544,577,611,647);
  frqtab : array[0..11] of word
  = (262,277,294,311,330,349,370,392,415,440,466,494);

procedure sbinitvoice(v : byte);
begin
  sbputout($20+vtab[v].m,$21);
  sbputout($20+vtab[v].p,$21);
  sbputout($40+vtab[v].m,$00);
  sbputout($40+vtab[v].p,$00);
  sbputout($60+vtab[v].m,$FF);
  sbputout($60+vtab[v].p,$FF);
  sbputout($80+vtab[v].m,$0F);
  sbputout($80+vtab[v].p,$0F);
  sbputout($A0+v,0);
  sbputout($B0+v,$10);
  sbputout($C0+v,$01);
  sbputout($E0+vtab[v].m,$00);
  sbputout($E0+vtab[v].p,$00);
end;

procedure sbinit;
begin
  if not sb then exit;
  sbputout($01,$00);
  sbputout($04,$00);
  sbputout($08,$00);
  sbputout($BD,$00);
  for i := 0 to 8 do sbinitvoice(i);
end;

procedure cleanupmusic;
begin
  if sb then sbinit;
  nosound;
  sndloaded := false;
end;

procedure startnew(name : string);
begin
  if music then begin
    sndloaded := false;
    if sb then begin
      delay(100);
      sbinit;
      delay(100);
    end else nosound;
    sndassign(name);
    reloadmus;
  end;
end;

procedure voicevolume(voice : byte);
var
  z : integer;
begin
  z := 63-musvol-sndchvol[voice]-sndntvol[voice];
  if z<0 then z := 0;
  if z>63 then z := 63;
  sbputout($40+vtab[voice].p,sbregs[$40+vtab[voice].p] and $C0 or z);
  if sbregs[$C0+voice] and 1=1 then begin
    sbputout($40+vtab[voice].m,sbregs[$40+vtab[voice].m] and $C0 or z);
  end;
end;

procedure cut(v : byte);
begin
  if v>8 then exit;
  if sb then sbputout($B0+v,sbregs[$B0+v] and $1F);
  if not sb or usepc then nosound;
end;

procedure play(v,note : byte);
var
  nf : word;
  bl : byte;
begin
  if v>8 then exit;
  if sb then begin
    nf := notetab[note mod 12];
    bl := note div 12-1;
    if bl>7 then exit;
    sbputout($A0+v,lo(nf));
    sbputout($B0+v,hi(nf) or bl shl 2 or $20);
  end;
  if not sb or usepc then begin
    bl := note div 12-1;
    if bl>7 then exit;
    if bl>=4 then sound(frqtab[note mod 12] shl (bl-4))
    else sound(frqtab[note mod 12] shr (4-bl));
  end;
end;

procedure snderror(str : string);
begin
  unprepare;
  writeln('ERROR DE SON : ',str);
  halt(2);
end;

procedure sndassign(name : string);
begin
  assign(sndf,name+'.MID');
  assign(insf,name+'.LGI');
end;

procedure reloadmus;
const
  identstring : array[0..3] of char = 'MThd';
var
  len : longint;
  ftyp,ntrk,inval : word;
begin
  if nosnd then exit;
  if sb then begin
    reset(insf,1);
    if ioresult<>0 then begin
      nosound;
      sbinit;
      sndloaded := false;
      exit;
    end;
    blockread(insf,instrs^,256*16);
    close(insf);
    io := ioresult;
  end;
  reset(sndf,1);
  sndcnt := 0;
  sndlen := filesize(sndf);
  if sndlen>32768 then sndlen := 32768;
  blockread(sndf,sndbuf^,sndlen);
  sndloaded := ioresult=0;
  if not sndloaded then begin
    nosound;
    sbinit;
  end else begin
    for i := 0 to 3 do if sndbuf^[i]<>byte(identstring[i]) then
      snderror('FICHIER MIDI INCORRECT!');
    len := 0;
    for i := 0 to 3 do len := len shl 8 or sndbuf^[i+4];
    ftyp := sndbuf^[8] shl 8+sndbuf^[9];
    if ftyp>1 then snderror('TYPE DE FICHIER INCONNU');
    ntrk := sndbuf^[10] shl 8+sndbuf^[11];
    if ntrk>32 then snderror('TROP DE PISTES');
    dtime := sndbuf^[12] shl 8+sndbuf^[13];
    sndcnt := 12+len;
    for i := 0 to ntrk-1 do begin
      len := 0;
      for j := 0 to 3 do len := len shl 8 or sndbuf^[sndcnt+j];
      sndtrk[i] := sndcnt+5; {+5 = on dpasse le premier delta time}
      sndend[i] := sndcnt+4+len;
      if sndend[i]>sndlen then snderror('DEBORDEMENT DE PISTE!!!');
      snddels[i] := 0;
      sndcom[i] := $80;
      inc(sndcnt,len+8);
    end;
    for i := ntrk to 31 do sndtrk[i] := 0;
    for i := 0 to 15 do sndchvol[i] := 0;
    for i := 0 to 15 do sndntvol[i] := 0;
    for i := 0 to 15 do sndins[i] := -1;
    inval := 1193180 div (dtime*2)*midispeed;
    setclk(inval);
  end;
  close(sndf);
  io := ioresult;
end;

procedure choixmus;
begin
  if tmpleno=1 then sndassign('LGD0')
  else if (tmpleno=2) or (tmpleno=76) or (tmpleno=77) then
    sndassign('JEU')
  else if (tmpleno>=5) and (tmpleno<=11) then begin
    case tmpleno of
      5 : sndassign('SOLEIL');
      6 : sndassign('LUNE');
      7 : sndassign('OCEAN');
      8 : sndassign('MONTS');
      9 : sndassign('TERRE');
      10 : sndassign('AIR');
      11 : sndassign('ASTRAL');
    end;
  end else if tmpleno=73 then sndassign('CASTLE')
  else if tmpleno=12 then sndassign('HADES2')
  else if mondeno=0 then begin
    if posx<50 then begin
      if posy<50 then sndassign('PRES')
      else if posy<100 then sndassign('AIR')
      else sndassign('OCEAN');
    end else if posx<100 then begin
      if posy<50 then sndassign('SOLEIL')
      else if posy<100 then sndassign('CENTRE')
      else sndassign('LUNE');
    end else begin
      if posy<50 then sndassign('MONTS')
      else if posy<100 then sndassign('TERRE')
      else sndassign('JEU');
    end;
  end else if mondeno=1 then begin
    if posx+posy<100 then sndassign('HADES1')
    else if posx+posy<200 then sndassign('HADES2')
    else sndassign('HADES3');
  end else if mondeno=2 then sndassign('ETHER')
  else if mondeno=3 then sndassign('ASTRAL');
  if not sndloaded then reloadmus;
end;