procedure preparerecouvrement;
begin
  ovrinit('LEGENDES.OVR');
  if ovrresult<>0 then begin
    textattr := $1D;
    writeln('Erreur au chargement du fichier de recouvrement (overlay)!');
  end;
  case ovrresult of
    ovrerror : writeln('Pas de partiel!');
    ovrnotfound : writeln('Fichier introuvable.');
    ovrnomemory : writeln('Mmoire insuffisante.');
    ovrioerror : writeln('Erreur E/S en chargement.');
  end;
  if ovrresult<>ovrok then halt(1);
  writeln('Chargement du fichier de recouvrement effectu...');
  if noemsovr then exit;
  ovrinitems;
  if (ovrresult<>ovrok) and (ovrresult<>ovrnoemsdriver)
    and (ovrresult<>ovrnoemsmemory) then begin
    textattr := $1D;
    writeln('Erreur ',ovrresult,' lors du remisage en EMS!');
    writeln('(Ceci n''est pas d  une simple absence d''EMS.)');
    halt(1);
  end;
  if ovrresult=ovrok then writeln('Remisage en EMS effectu...')
  else if ovrresult=ovrnoemsdriver then
    writeln('Remisage en EMS non effectu (pas d''EMS)...')
  else writeln('Remisage en EMS non effectu (pas assez d''EMS)...');
end;

procedure configure;
begin
  io := 0;
  assign(configf,'LEGENDES.CFG');
  rewrite(configf,1);
  io := io or ioresult;
  writeln('CONFIGURATION DE LEGENDES');
  writeln;
  writeln('Cartes graphiques:');
  writeln('@) Autodtection (a ne marche pas)');
  writeln('A) CGA');
  writeln('B) EGA');
  writeln('C) VGA');
  writeln('D) VGA rapide ou SVGA');
  writeln('E) Trident 800x600x256 (uniquement)');
  repeat
    c := readkey;
    c := upcase(c);
    if c=#27 then halt(1);
  until (c>='@') and (c<='E');
  writeln(c);
  t1 := byte(c)-64;
  blockwrite(configf,t1,1);
  io := io or ioresult;
  writeln;
  writeln('Sorties sonores:');
  writeln('@) Autodtection (a marche)');
  writeln('A) Aucune');
  writeln('B) Haut-parleur interne PC');
  writeln('C) Carte AdLib');
  writeln('D) Carte Sound Blaster');
  writeln('E) Carte Sound Blaster Pro');
  repeat
    c := readkey;
    c := upcase(c);
    if c=#27 then halt(1);
  until (c>='@') and (c<='E');
  writeln(c);
  t1 := byte(c)-64;
  blockwrite(configf,t1,1);
  io := io or ioresult;
  if (t1=4) or (t1=5) then begin
    writeln;
    writeln('Ports voix:');
    writeln('@) Standard (220h)');
    writeln('A) 210h (PAS SB-PRO)');
    writeln('B) 220h');
    writeln('C) 230h (PAS SB-PRO)');
    writeln('D) 240h');
    writeln('E) 250h (PAS SB-PRO)');
    writeln('F) 260h (PAS SB-PRO)');
    repeat
      c := readkey;
      c := upcase(c);
      if c=#27 then halt(1);
    until (c>='@') and (c<='F') and ((t1=4) or (c='@') or (c='B') or (c='D'));
    writeln(c);
    t2 := byte(c)-64;
    blockwrite(configf,t2,1);
    io := io or ioresult;
    writeln;
    writeln('IRQ (ReQutes d''Interruption)');
    writeln('@) Standard (IRQ7)');
    writeln('A) IRQ2');
    writeln('B) IRQ3 (PAS SB-PRO)');
    writeln('C) IRQ5');
    writeln('D) IRQ7');
    writeln('E) IRQ10 (SEULEMENT SB-PRO)');
    repeat
      c := readkey;
      c := upcase(c);
      if c=#27 then halt(1);
    until (c>='@') and (c<='E') and ((t1=4) or (c<>'B')) and ((t1=5) or (c<>'E'));
    writeln(c);
    t2 := byte(c)-64;
    blockwrite(configf,t2,1);
    io := io or ioresult;
    if t1=5 then begin
      writeln;
      writeln('Canal DMA (Accs Direct  la Mmoire)');
      writeln('@) Standard (DMA1)');
      writeln('A) DMA0');
      writeln('B) DMA1');
      writeln('C) DMA3');
      repeat
        c := readkey;
        c := upcase(c);
        if c=#27 then halt(1);
      until (c>='@') and (c<='C');
      writeln(c);
      t2 := byte(c)-64;
      blockwrite(configf,t2,1);
      io := io or ioresult;
    end;
  end;
  close(configf);
  io := io or ioresult;
  writeln;
  if io=0 then begin
    writeln('C''est fait! Relancez  prsent LEGENDES!');
    halt(0);
  end else begin
    writeln('Il y a eu erreur lors de l''criture du fichier de configuration!');
    halt(1);
  end;
end;

procedure prepareparams;
begin
  nosvga := false;
  nohi := false;
  nopal := false;
  novga := false;
  noega := false;
  bw := false;
  nosb := false;
  nosnd := false;
  usepc := false;
  midispeed := 1;
  novoc := false;
  vocport := 0;
  vocirq := 0;
  vocdma := 65535;
  vocpro := false;
  noemsovr := false;
  b1 := false;
  for i := 1 to paramcount do begin
    s := paramstr(i);
    for j := 1 to length(s) do s[j] := upcase(s[j]);
    if s='/MEM' then b1 := true
    else if s='/CFG' then configure
    else if s='/NOSVGA' then nosvga := true
    else if s='/NOHI' then begin
      nohi := true;
      nosvga := true;
    end
    else if s='/NOPAL' then nopal := true
    else if s='/EGA' then begin
      novga := true;
      nohi := true;
      nosvga := true;
      nopal := true;
    end
    else if s='/CGA' then begin
      noega := true;
      novga := true;
      nohi := true;
      nosvga := true;
      nopal := true;
    end
    else if s='/BW' then bw := true
    else if s='/NOSB' then nosb := true
    else if s='/NOSND' then begin
      nosnd := true;
      nosb := true;
    end
    else if s='/USEPC' then usepc := true
    else if s='/MS1' then midispeed := 1
    else if s='/MS2' then midispeed := 2
    else if s='/MS3' then midispeed := 3
    else if s='/MS4' then midispeed := 4
    else if s='/MS5' then midispeed := 5
    else if s='/NOVOC' then novoc := true
    else if s='/PRO' then vocpro := true
    else if s='/P210' then vocport := $210
    else if s='/P220' then vocport := $220
    else if s='/P230' then vocport := $230
    else if s='/P240' then vocport := $240
    else if s='/P250' then vocport := $250
    else if s='/P260' then vocport := $260
    else if copy(s,1,2)='/P' then begin
      writeln('Port inconnu: ',copy(s,3,length(s)-2));
      writeln('(Ports valables: 210, 220, 230, 240, 250, 260)');
      halt(1);
    end
    else if s='/I2' then vocirq := 2
    else if s='/I02' then vocirq := 2
    else if s='/I3' then vocirq := 3
    else if s='/I03' then vocirq := 3
    else if s='/I5' then vocirq := 5
    else if s='/I05' then vocirq := 5
    else if s='/I7' then vocirq := 7
    else if s='/I07' then vocirq := 7
    else if s='/I10' then vocirq := 10
    else if copy(s,1,2)='/I' then begin
      writeln('IRQ inconnu: ',copy(s,3,length(s)-2));
      writeln('(IRQ valables: 2, 3, 5, 7, 10)');
      halt(1);
    end
    else if s='/D0' then vocdma := 0
    else if s='/D1' then vocdma := 1
    else if s='/D3' then vocdma := 3
    else if copy(s,1,2)='/D' then begin
      writeln('Canal DMA inconnu: ',copy(s,3,length(s)-2));
      writeln('(Canaux DMA valables: 0, 1, 3)');
      halt(1);
    end
    else if s='/NOEMS' then noemsovr := true
    else if s='/?' then begin
      writeln(nomjeu,'  ',verstr);
      writeln('Liste des paramtres:');
      writeln('Param.':10,'Memoire':10,'   Effet');
      writeln('/MEM':10,'':10,
        '   Demande la mmoire disponible');
      writeln('/CFG':10,'':10,
        '   Configure');
      writeln('/NOSVGA':10,0:10,'   Empche le mode SVGA (Trident)');
      writeln('/NOHI':10,-nbicos*(16*16+32*32):10,
        '   Empche le chargement des Supericnes (implique /NOSVGA)');
      writeln('/NOPAL':10,0:10,
        '   Empche la modification rapide de la palette (VGA)');
      writeln('/EGA':10,-nbicos*(16*16+32*32):10,
        '   Utilise seulement EGA (implique /NOHI)');
      writeln('/CGA':10,-nbicos*(16*16+32*32):10,
        '   Utilise seulement CGA (implique /NOHI)');
      writeln('/BW':10,0:10,
        '   Force le mode noir et blanc (VGA/SVGA seulement)');
      writeln('/NOSB':10,-256*16:10,
        '   Pas de carte Sound Blaster');
      writeln('/NOSND':10,-32768+256*16:10,
        '   Empche le son (implique /NOSB)');
      writeln('/USEPC':10,-0:10,
        '   Utilise le haut-parleur ET la Sound Blaster');
      writeln('/NOVOC':10,-65520-3907:10,
        '   Interdit la voix synthtise');
      writeln('/P[nnn]':10,0:10,
        '   Fixe le port Voice (PAS le port musical) Df.:220');
      writeln('/I[nn]':10,0:10,
        '   Fixe le numro IRQ pour CT-VOICE Df.:7');
      writeln('/D[nn]':10,0:10,
        '   Fixe le canal DMA pour CT-VOICE Df.:1');
      writeln('/PRO':10,5014-3907:10,
        '   Carte SB Pro (plutt que SB normale)');
      writeln('/NOEMS':10,0:10,
        '   Interdit le remisage en EMS');
      writeln('/MS[n]':10,0:10,
        '   Acclre la lecture du fichier MIDI (n fois)');
      halt(0);
    end
    else begin
      writeln('Paramtre inconnu: ',s);
      writeln('(/? Pour la liste des paramtres valides)');
      halt(1);
    end;
  end;
end;

procedure prepareconfig;
begin
  assign(configf,'LEGENDES.CFG');
  reset(configf,1);
  blockread(configf,t1,1);
  case t1 of
    1 : begin
      noega := true;
      novga := true;
      nohi := true;
      nosvga := true;
      nopal := true;
    end;
    2 : begin
      novga := true;
      nohi := true;
      nosvga := true;
      nopal := true;
    end;
    3 : begin
      nosvga := true;
      nopal := true;
    end;
    4 : begin
      nosvga := true;
    end;
  end;
  blockread(configf,t1,1);
  case t1 of
    1 : begin
      nosnd := true;
      nosb := true;
      novoc := true;
    end;
    2 : begin
      nosb := true;
      novoc := true;
    end;
    3 : begin
      novoc := true;
    end;
    5 : begin
      vocpro := true;
    end;
  end;
  if (t1=4) or (t1=5) then begin
    blockread(configf,t2,1);
    if vocport=0 then case t2 of
      1 : vocport := $210;
      2 : vocport := $220;
      3 : vocport := $230;
      4 : vocport := $240;
      5 : vocport := $250;
      6 : vocport := $260;
    end;
    blockread(configf,t2,1);
    if vocirq=0 then case t2 of
      1 : vocirq := 2;
      2 : vocirq := 3;
      3 : vocirq := 5;
      4 : vocirq := 7;
      5 : vocirq := 10;
    end;
    if t1=5 then begin
      blockread(configf,t2,1);
      if vocdma=65535 then case t2 of
        1 : vocdma := 0;
        2 : vocdma := 1;
        3 : vocdma := 3;
      end;
    end;
  end;
  close(configf);
  if vocport=0 then vocport := $220;
  if vocirq=0 then vocirq := 7;
  if vocdma=65535 then vocdma := 1;
  if ioresult<>0 then configure;
end;

procedure preparemateriel;
begin
  if not noega then begin
    i := port[$3C2];
    if i=$FF then begin
      noega := true;
      novga := true;
      nohi := true;
      nosvga := true;
      nopal := true;
    end;
  end;
  if not novga then begin
    port[$3D4] := $15;
    i := port[$3D5];
    if i=$FF then begin
      novga := true;
      nohi := true;
      nosvga := true;
      nopal := true;
    end;
  end;
  if not nosvga then begin
    port[$3C4] := $0E;
    i := port[$3C5];
    if i=$FF then nosvga := true;
  end;
  if not nosb then begin
    sbputout(1,0);
    sbputout(4,$60);
    sbputout(4,$80);
    i := port[$388];
    sbputout(2,$FF);
    sbputout(4,$21);
    for j := 1 to 1000 do k := port[$388];
    k := port[$388];
    sbputout(4,$60);
    sbputout(4,$80);
    sbpresent := (i and $E0=0) and (k and $E0=$C0);
  end;
  sb := sbpresent and not nosb;
  if not novoc then begin
    new(vocp);
    chargectvoice;
    if not ctok then novoc := true;
  end;
end;

procedure preparememoire;
begin
  memneeded := 150*150*2*2+ecrpiletaille*(25*80*2+16);
  if not nosnd then inc(memneeded,32768);
  if sb then inc(memneeded,256*16);
  if not nohi then inc(memneeded,nbicos*(16*16+32*32));
  if not novoc then inc(memneeded,65520);
  if b1 or (maxavail<memneeded) then begin
    textattr := $1F;
    if maxavail<memneeded then begin
      textattr := $1C;
      writeln('Mmoire insuffisante pour charger LEGENDES!');
    end;
    writeln('Mmoire disponible : ',memavail:6);
    writeln('Mmoire requise    : ',memneeded-maxavail+memavail:6);
    if maxavail<memneeded then begin
      writeln('Mmoire manquante  : ',memneeded-maxavail:6);
      writeln('Essayez avec /NOHI, /NOSND ou /NOVOC');
      writeln('(/? donne la liste des paramtres)');
      halt(1);
    end else begin
      writeln('Mmoire libre      : ',maxavail-memneeded:6);
      halt(0);
    end;
  end;
end;

procedure preparedivers;
begin
  randomize;
  textattr := $1F;
  for i := 0 to 149 do new(monde[i]);
  for i := 0 to 149 do new(mondeo[i]);
  for i := 1 to ecrpiletaille do new(ecrpile[i]);
  ecrpileptr := 0;
  gmode := false;
  showg := not noega;
  smode := false;
  shows := false;
  vmode := false;
  showv := false;
  plein := false;
  for i := 0 to 255 do cv[i] := char(i);
  trich_montr := false;
  nosound;
  if sb then sbinit;
  setclk(6214);
  if not nosnd then begin
    sndassign('LGD0');
    new(sndbuf);
    if sb then begin
      new(instrs);
      musvol := 0;
    end;
    reloadmus;
    music := true;
  end;
  colcnt := $FFFF;
  clkcount := $0000;
  setintvec($08,@mytimer);
  if bw and not novga then begin
    regs.ax := $1200;
    regs.bl := $33;
    intr($10,regs);
    regs.ax := $101B;
    regs.bx := 0;
    regs.cx := 256;
    intr($10,regs);
  end;
  dernieres[0].r := 0;
  dernieres[0].g := 53;
  dernieres[0].b := 10;
  dernieres[1].r := 33;
  dernieres[1].g := 0;
  dernieres[1].b := 0;
  dernieres[2].r := 33;
  dernieres[2].g := 33;
  dernieres[2].b := 0;
  dernieres[3].r := 0;
  dernieres[3].g := 33;
  dernieres[3].b := 0;
  dernieres[4].r := 0;
  dernieres[4].g := 0;
  dernieres[4].b := 33;
  dernieres[5].r := 33;
  dernieres[5].g := 33;
  dernieres[5].b := 33;
  dernieres[6].r := 63;
  dernieres[6].g := 33;
  dernieres[6].b := 0;
  dernieres[7].r := 33;
  dernieres[7].g := 33;
  dernieres[7].b := 63;
  dernpal;
  if not novga then begin
    preparevgapalettes;
    selectpalette(0,true);
  end else if not noega then selectpalette(0,true);
  if not noega then begin
    assign(fontf,'FONT.EGA');
    reset(fontf,1);
    blockread(fontf,font,4096);
    fontloaded := ioresult=0;
  end;
  zedessins;
  for i := 0 to 255 do bios[i] := mem[$F000:$FF00+i];
end;

procedure prepare;
begin
  getintvec($08,@oldtimer);
  textattr := $1F;
  checkbreak := false;
  prepareparams;
  prepareconfig;
  preparerecouvrement;
  preparemateriel;
  preparememoire;
  preparedivers;
end;