CODE    SEGMENT WORD PUBLIC

        ASSUME  CS:CODE

        PUBLIC  PUTBLOCK

X       EQU     WORD PTR [BP+12]
Y       EQU     WORD PTR [BP+10]

PUTBLOCK PROC    FAR

;INITIALISATION
        PUSH    BP
        MOV     BP,SP
        PUSH    DS

;LECTURE DE L'ADRESSE DU BLOC
        MOV     AX,SS:[BP+8]
        MOV     DS,AX
        MOV     SI,SS:[BP+6]

;SELECTION DU SEGMENT DE LA MEMOIRE ECRAN
        MOV     AX,0A000h
        MOV     ES,AX

;CALCUL DE L'ADRESSE DU PREMIER POINT
        MOV     AX,Y
        MOV     BX,80d
        MUL     BX
        MOV     DX,AX
        MOV     AX,X
        MOV     CL,3
        SHR     AX,CL
        ADD     AX,DX
        MOV     DI,AX
        PUSH    AX

;CALCUL DU MASQUE
        MOV     CX,X
        NOT     CL
        AND     CL,7
        MOV     BL,00000001b
        SHL     BL,CL
        PUSH    BX

;ENVOI DES DONNEES PREMIERES DANS LES PORTS
        MOV     DX,3CEh
        MOV     AX,0205h
        OUT     DX,AX
        MOV     AL,08h
        OUT     DX,AL
        INC     DX

;DEBUT BOUCLE
        MOV     CX,40h
BOUCLE  LABEL   NEAR

;ENVOI DU MASQUE A LA CARTE
        MOV     AL,BL
        OUT     DX,AL

;INSTRUCTION DE LECTURE POUR INITIALISER LES LATCHES
        MOV     AL,ES:[DI]

;ECRITURE DU POINT
        MOV     AL,DS:[SI]
        CMP     AL,16
        JAE     NOPUT
        MOV     ES:[DI],AL
NOPUT   LABEL   NEAR

;CHARGER COULEUR SUIVANTE
        INC     SI

;DECALAGE DU MASQUE
        SHR     BL,1

;SI OCTET SUIVANT
        CMP     BL,0
        JNZ     MEMEO

;REINITIALISATION DU MASQUE
        MOV     BL,80h

;OCTET SUIVANT
        INC     DI

;SI LIGNE SUIVANTE
MEMEO   LABEL   NEAR
        MOV     AL,CL
        AND     AL,7
        CMP     AL,1
        JNZ     MEMEL

;REPRISE DU MASQUE INITIAL
        POP     BX

;REPRISE DE L'ADRESSE INITIALE
        POP     DI

;LIGNE SUIVANTE
        ADD     DI,80d

;SAUVEGARDE DE L'ADRESSE
        PUSH    DI

;...ET DU MASQUE
        PUSH    BX

;FIN DE BOUCLE
MEMEL   LABEL   NEAR
        LOOP    BOUCLE

;RESTAURATION DES PORTS
        MOV     DX,3CEh
        MOV     AX,0005h
        OUT     DX,AX
        MOV     AX,0FF08h
        OUT     DX,AX

;RESTAURATION DE LA PILE
        POP     AX
        POP     AX

;RESTAURATION DU CONTEXTE
        POP     DS
        POP     BP
        RET     8

PUTBLOCK ENDP

CODE    ENDS

        END
