procedure effet(n : longint);
begin
  {
  if novoc then exit;
  if ctstatus<>0 then coupevoc;
  chargevdat('EFFETS',n*8);
  *** SPECIAL EDITION
  }
end;

function upcase(ch : char) : char;
const
  majuscules : array[0..254] of char
  = '                '
  + '                '
  + ' !"#$%&''()*+,-./'
  + '0123456789:;<=>?'
  + '@ABCDEFGHIJKLMNO'
  + 'PQRSTUVWXYZ[\]^_'
  + '`ABCDEFGHIJKLMNO'
  + 'PQRSTUVWXYZ{|}~ '
  + 'CUEAAAACEEEIIIAA'
  + 'EOOOUUYOU     '
  + 'AIOUNN          '
  + '                '
  + '                '
  + '                '
  + '                '
  + '               ';
begin
  if ch<=#32 then upcase := ch
  else if ch=#255 then upcase := #32 else
    upcase := majuscules[byte(ch)];
end;

procedure traitechaine(is : string;var os : string);
var
  i : byte;
begin
  for i := 1 to length(is) do is[i] := upcase(is[i]);
  os := '';
  for i := 1 to length(is) do if (is[i]>=#48) and (is[i]<#58)
    or (is[i]>=#65) and (is[i]<#91) or (is[i]>=#128) then os := os+is[i];
  os := copy(os,1,5);
end;

procedure autour(s1,s2 : string);
var
  i : byte;
begin
  i := 40 - length(s1);
  gotoxy(i,wherey);
  writeln(s1,s2);
end;

procedure justifie(s : string);
var
  i : byte;
begin
  for i := 1 to length(s) do
    if (wherex>=65) and (s[i]=' ') then writeln
    else if wherex>=78 then write('-',#13,#10,s[i])
    else write(s[i]);
end;

procedure centrer(s : string);
begin
  gotoxy(40-length(s) div 2,wherey);
  writeln(s);
end;

procedure waitkey;
var
  c1,c2 : char;
begin
  while keypressed do c1 := crt.readkey;
  repeat
    c1 := crt.readkey;
    if c1=#00 then c2 := crt.readkey;
  until c1<>#00;
end;

function readkey : char;
var
  c1,c2 : char;
begin
  repeat until keypressed;
  c1 := #$FF;
  while keypressed do begin
    c2 := c1;
    c1 := crt.readkey;
  end;
  if c2=#00 then begin
    skey := c1;
    readkey := c2;
  end else readkey := c1;
end;

{$F+}

{$L ROUTASM}

procedure dessinduchar(n : byte;d : dessin);
external;

procedure fondbrillant;
external;

{$F-}

procedure setegapalette(p : egapalette);
begin
  if not novga or noega then exit;
  regs.ax := $1002;
  regs.es := seg(p);
  regs.dx := ofs(p);
  intr($10,regs);
end;

procedure setvgapalette(num : byte;p : vgapalette);
begin
  if novga then exit;
  regs.ax := $1012;
  regs.bx := num*16;
  regs.cx := 16;
  regs.es := seg(p);
  regs.dx := ofs(p);
  intr($10,regs);
end;

procedure preparevgapalettes;
begin
  if novga then exit;
  regs.ax := $1013;
  regs.bh := $01;
  regs.bl := $00;
  intr($10,regs);
  regs.ax := $1002;
  regs.es := seg(provga);
  regs.dx := ofs(provga);
  intr($10,regs);
  setvgapalette(0,stdvga);
  setvgapalette(1,jour);
  setvgapalette(2,nuit);
  setvgapalette(3,matin);
  setvgapalette(4,soir);
  setvgapalette(5,artificiel);
  setvgapalette(6,enfer);
end;

procedure selectpalette(num : byte;force : boolean);
begin
  if (num=curpal) and not force then exit;
  if novga then begin
    if noega then exit
    else begin
      regs.ax := $1002;
      regs.es := seg(egapals[num]);
      regs.dx := ofs(egapals[num]);
      intr($10,regs);
    end;
  end else begin
    regs.ax := $1013;
    regs.bh := num;
    regs.bl := $01;
    intr($10,regs);
  end;
  curpal := num;
end;

procedure zedessins;
begin
  if not noega then begin
    if fontloaded then begin
      regs.ax := $1100;
      regs.bh := 16;
      regs.bl := 0;
      regs.cx := 256;
      regs.dx := 0;
      regs.es := seg(font);
      regs.bp := ofs(font);
      intr($10,regs);
    end;
    fondbrillant;
  end else begin
    cv[208] := '&'; cv[204] := '&';
    cv[205] := '#'; cv[207] := '*';
    cv[206] := '%'; cv[220] := '_';
    cv[221] := '.'; cv[222] := '!';
    cv[223] := '^'; cv[224] := #177;
    cv[225] := #00; cv[226] := '^';
    cv[227] := '~'; cv[228] := #177;
    cv[229] := #00; cv[230] := '''';
    cv[231] := ''''; cv[232] := '.';
    cv[233] := #00; cv[234] := '.';
    cv[235] := #177;
    cv[236] := '.'; cv[237] := '!';
    cv[238] := '^'; cv[239] := #177;
    cv[209] := '''';
    cv[210] := ''''; cv[211] := #239;
    cv[212] := #249; cv[213] := #227;
    cv[214] := '"'; cv[215] := #239;
    cv[216] := 'w';
  end;
end;

procedure grzedessins;
begin
  regs.ax := $1121;
  regs.bl := $02;
  regs.cx := 16;
  regs.es := seg(font);
  regs.bp := ofs(font);
  intr($10,regs);
end;

procedure setclk(inval : word);
begin
  port[$43] := $36;
  port[$40] := lo(inval);
  port[$40] := hi(inval);
  clkval := inval;
end;

procedure unprepare;
var
  w1,w2,w3 : word;
begin
  setclk($FFFF);
  setintvec($08,@oldtimer);
  sbinit;
  nosound;
  arretect;
  regs.ax := $0003;
  intr($10,regs);
  if meml[0:$68]=0 then exit;
  regs.ah := $04;
  intr($1A,regs);
  w1 := (regs.ch shr 4)*1000+(regs.ch and $0F)*100
    +(regs.cl shr 4)*10+regs.cl and $0F;
  w2 := (regs.dh shr 4)*10+regs.dh and $0F;
  w3 := (regs.dl shr 4)*10+regs.dl and $0F;
  setdate(w1,w2,w3);
  regs.ah := $02;
  intr($1A,regs);
  w1 := (regs.ch shr 4)*10+regs.ch and $0F;
  w2 := (regs.cl shr 4)*10+regs.cl and $0F;
  w3 := (regs.dh shr 4)*10+regs.dh and $0F;
  settime(w1,w2,w3,0);
end;

procedure jeufini;
begin
  unprepare;
  textattr := $1F;
  justifie('Nous vous remercions d''avoir jou  LEGENDES et ');
  justifie('esprons vous revoir trs bientt sur notre jeu!');
  writeln;
  halt(0);
end;

procedure incpv(n : longint);
begin
  if per.pv+n<per.pvm then inc(per.pv,n)
    else per.pv := per.pvm;
end;

procedure incpm(n : longint);
begin
  if per.pm+n<per.pmm then inc(per.pm,n)
    else per.pm := per.pmm;
end;

{function suivant(n : longint) : longint;
const
  tab : array[0..39] of longint =
  (100,200,300,400,500,600,700,800,900,1000,
  1200,1400,1600,1800,2000,2500,3000,3500,4000,4500,
  5000,6000,7000,8000,9000,10000,11000,12000,13000,14000,
  16000,18000,20000,22000,24000,26000,28000,30000,35000,40000);
begin
  if n<0 then begin suivant := 0; exit; end;
  if n<40 then suivant := tab[n] else suivant := (n-39)*10000+40000;
end;}

{function suivant(n : longint) : longint;
const
  tab : array[0..39] of longint =
  (500,1000,1500,2000,2500,3000,3500,4000,4500,5000,
  6500,7000,7500,8000,8500,9000,9500,10000,11000,12000,
  13000,14000,15000,16000,17000,18000,19000,20000,22000,24000,
  26000,28000,30000,34000,38000,42000,48000,54000,62000,70000);
begin
  if n<0 then begin suivant := 0; exit; end;
  if n<40 then suivant := tab[n] else suivant := (n-39)*10000+70000;
end;}

function suivant(n : longint) : longint;
const
  tab : array[0..39] of longint =
  (200,400,600,800,1000,1500,2000,2500,3000,3500,
  4000,4500,5000,5500,6000,6500,7000,8000,9000,10000,
  11000,12000,13000,14000,15000,16000,17000,18000,20000,22000,
  24000,26000,28000,30000,35000,40000,45000,50000,55000,60000);
begin
  if n<0 then begin suivant := 0; exit; end;
  if n<40 then suivant := tab[n] else suivant := (n-39)*10000+60000;
end;

procedure calculeperbienmal;
begin
  case races[per.race].mtype of
    0 : begin
      per.pbien := 500;
      per.pmal := -1000;
    end;
    1 : begin
      per.pbien := 1000;
      per.pmal := -5000;
    end;
    2 : begin
      per.pbien := 0;
      per.pmal := -500;
    end;
    else begin
      writeln('Comment est-ce que vous avez fait a?');
      per.pbien := 0;
      per.pmal := 0;
    end;
  end;
end;

function evalue(p : personnage) : longint;
begin
  evalue := p.pv+p.pm+p.frc+p.int+p.dex+p.armdomtot+p.armurdomtot;
end;

function possede(o,ss : byte) : boolean;
var
  i : integer;
begin
  possede := false;
  for i := 0 to per.nequipt-1 do
    if (per.equipt[i].code=o) and (per.equipt[i].sstype=ss)
      then possede := true;
end;

function eqquant(o,ss : byte) : word;
var
  i : integer;
  t : word;
begin
  t := 0;
  for i := 0 to per.nequipt-1 do
    if (per.equipt[i].code=o) and (per.equipt[i].sstype=ss)
      then inc(t,per.equipt[i].quan);
  eqquant := t;
end;

procedure addequip(o,ss : byte);
var
  i : integer;
begin
  for i := 0 to per.nequipt-1 do with per.equipt[i] do
    if (code=o) and (sstype=ss) and (quan>0) then begin
      inc(quan);
      exit;
    end;
  with per.equipt[per.nequipt] do begin
    code := o;
    sstype := ss;
    quan := 1;
    portee := false;
    maudite := false;
    charges := 0;
    for i := 3 to 15 do reserved[i] := 0;
  end;
  inc(per.nequipt);
end;

procedure add0equip(o,ss : byte);
var
  i : integer;
begin
  with per.equipt[per.nequipt] do begin
    code := o;
    sstype := ss;
    quan := 0;
    portee := false;
    maudite := false;
    charges := 0;
    for i := 3 to 15 do reserved[i] := 0;
  end;
  inc(per.nequipt);
end;

procedure addarme(o,ss : byte;dom : integer;maud : boolean;fr,it,dx : integer);
var
  i : byte;
begin
  with per.equipt[per.nequipt] do begin
    code := o;
    domm := dom;
    quan := 0;
    maudite := maud;
    portee := false;
    bonfrc := fr;
    bonint := it;
    bondex := dx;
    for i := 0 to 15 do reserved[i] := 0;
  end;
  inc(per.nequipt);
end;

procedure addquant(o,ss : byte;q : word);
var
  i : integer;
begin
  if q=0 then exit;
  for i := 0 to per.nequipt-1 do with per.equipt[i] do
    if (code=o) and (sstype=ss) and (quan>0) then begin
      inc(quan,q);
      exit;
    end;
  with per.equipt[per.nequipt] do begin
    code := o;
    sstype := ss;
    quan := q;
    portee := false;
    maudite := false;
    charges := 0;
    for i := 3 to 15 do reserved[i] := 0;
  end;
  inc(per.nequipt);
end;

procedure subequip(o,ss : byte);
var
  i,j : integer;
  oo : byte;
begin
  for i := 0 to per.nequipt-1 do
    if (per.equipt[i].code=o) and (per.equipt[i].sstype=ss) then begin
      with per.equipt[i] do begin
        if quan>1 then begin
          dec(quan);
          exit;
        end;
      end;
      for j := 0 to 19 do begin
        oo := per.corpus[j];
        if (oo=i) then per.corpus[j] := 1
        else if (oo>i) then dec(per.corpus[j]);
      end;
      for j := i to per.nequipt-2 do
        per.equipt[j] := per.equipt[j+1];
      dec(per.nequipt);
      exit;
    end;
end;

procedure decrisobjet(o : byte);
begin
  with per.equipt[o] do begin
    if code>32 then begin
      write(o:3,')    ',singul[code]:32);
      if portee then write(' P') else write('  ');
      if maudite and portee
        then write(' M') else write('  ');
      write(domm:4);
      write('   (',bonfrc:3,',',bonint:3,',',bondex:3,')');
    end else begin
      if quan<=1 then
        write(o:3,')    ',singul[code]:32)
      else write(o:3,')    ',quan:5,' ',pluriel[code]:26);
      if code=1 then begin
        if quan=1 then write(potsg[sstype]:14,'':10)
        else write(potpl[sstype]:14,'':10);
      end else if code=3 then begin
        write(bagts[sstype]:14);
        if charges=0 then write(' (casse) ') else write('':10);
      end else if code=4 then begin
        write(annx[sstype]:14);
        if portee then write(' P') else write('  ');
        write('':8);
      end else write('':24);
    end;
  end;
end;

function passable(tx,ty : integer) : boolean;
var
  bl : boolean;
begin
  bl := per.sorts[12] or per.sorts[38];
  passable :=
    (tx>=0) and (tx<150) and (ty>=0) and (ty<150) and
    ((monde[tx]^[ty].a<>0) or per.sorts[7] or bl or
      per.sorts[13] or (monde[tx]^[ty].b=78)) and
    (((monde[tx]^[ty].a<>3) and (monde[tx]^[ty].a<>18))
      or per.sorts[10] or bl) and
    (monde[tx]^[ty].a<>5) and (monde[tx]^[ty].a<>7) and
    (monde[tx]^[ty].a<>9) and ((monde[tx]^[ty].b<>75) or (possede(12,0)))
    and (monde[tx]^[ty].a<>15) and
    ((monde[tx]^[ty].a=0) or not per.sorts[13] or bl);
end;

function navigable(dir : integer) : boolean;
begin
  navigable :=
    not per.sorts[13] or
    (vfor>0) and (((dir+8-vdir) mod 8)<=1) or (((dir+8-vdir) mod 8)=7);
end;

procedure malef(x,y : integer);
begin
  if quit or (x<0) or (y<0) or (x>=150) or (y>=150) then exit;
  if (md^[x]^[y].b=1) then begin
    perdu;
    exit;
  end;
  case md^[x]^[y].a of
    1 : md^[x]^[y].a := 16;
    2 : md^[x]^[y].a := 17;
    3 : md^[x]^[y].a := 18;
    4 : md^[x]^[y].a := 19;
    11,12,14 : md^[x]^[y].a := 16;
  end;
  if (md^[x]^[y].b>=13) and (md^[x]^[y].b<=19) then md^[x]^[y].b := 29;
  if (md^[x]^[y].b=2) then md^[x]^[y].b := 0;
  if (md^[x]^[y].b>=5) and (md^[x]^[y].b<=11) then begin
    tombes[md^[x]^[y].b] := true;
    md^[x]^[y].b := 0;
  end;
end;

function malq(x,y : integer) : boolean;
begin
  malq :=
    (md^[x]^[y].a>=16) and (md^[x]^[y].a<=19);
end;

procedure deplmonstres;
const
  ad = 20;
var
  zona : array[-ad..ad,-ad..ad] of byte;
  i,j,k,l : longint;
begin
  for i := posx-ad to posx+ad do for j := posy-ad to posy+ad do
    if (i>=0) and (i<150) and (j>=0) and (j<150) and
    (monde[i]^[j].b>12) and (monde[i]^[j].b<=12+nbmonstres) then
      zona[i-posx,j-posy] := 1
    else
      zona[i-posx,j-posy] := 0;
  for i := posx-ad to posx+ad do for j := posy-ad to posy+ad do
    if zona[i-posx,j-posy]>0 then begin
      if (random(4)=0) then begin
        k := i+random(3)-1;
        l := j+random(3)-1;
      end else if (random(10)=0) then begin
        if (i>posx) then k := i-1
        else if (i<posx) then k := i+1
        else k := i;
        if (j>posy) then l := j-1
        else if (j<posy) then l := j+1
        else l := j;
      end else begin
        k := i;
        l := j;
      end;
      if (k>=0) and (k<150) and (l>=0) and (l<150) and (monde[k]^[l].a<>5)
      and (monde[k]^[l].a<>9) and (monde[k]^[l].a<>15) and
      (   (((monde[k]^[l].a=1) or (monde[k]^[l].a=2) or
      (monde[k]^[l].a=4) or (monde[k]^[l].a=6) or
      (monde[k]^[l].a=8) or (monde[k]^[l].a=13) or
      (monde[k]^[l].a=14) or (monde[k]^[l].a=16)
      or (monde[k]^[l].a=17) or (monde[k]^[l].a=19)
      or (monde[i]^[j].b=22) or
      (monde[i]^[j].b=26) or (monde[i]^[j].b=30) or
      (monde[i]^[j].b=36)) and (monde[i]^[j].b<>39) and (monde[i]^[j].b<>40)
      and (monde[i]^[j].b<>41))   or   ((monde[k]^[l].a=0) and
      ((monde[i]^[j].b=39) or (monde[i]^[j].b=40) or
      (monde[i]^[j].b=41)))   )     and (monde[k]^[l].b=0) then begin
        monde[k]^[l].b := monde[i]^[j].b;
        monde[i]^[j].b := 0;
        zona[i-posx,j-posy] := 0;
      end;
    end;
end;
