program treatvoc;

{$N+,E-}

uses
  dos,
  crt;

type
  datablock = array[0..32767] of byte;

const
  frq : array[0..12] of extended
  = (0.275,0.389,0.550,0.779,1.100,1.556,2.200,3.111,
  4.400,6.223,8.800,12.445,17.600);

var
  i,j,k,l,m,n,o,p : longint;
  s : string;
  f,g : file;
  data,data2 : array[0..255] of ^datablock;
  add,len,len2 : longint;
  b,sr,pk : byte;
  w : integer;
  header : record
    stamp : array[$00..$13] of char;
    add : word;
    ver : word;
    chk : word;
  end;
  lno1,lno2 : byte;
  tm,x1,x2,y1,y2,z : extended;
  echolen : word;
  echoatt : extended;
  echo : array[0..3999] of single;
  q,qd,qdd,r,ac,l_,equal : array[0..12] of extended;
  e,outs,step : extended;
  subdiv : longint;
  c : char;
  zdsp,pfct,pdsp,pqdt,nfct,ndsp,nqdt,v1,v2 : extended;
  vini,vmid,vfin : extended;
  midp : longint;
  regs : registers;

procedure putdot(x,y : word;c : byte);
begin
  regs.ah := $0C;
  regs.al := c;
  regs.cx := x;
  regs.dx := y;
  intr($10,regs);
end;

function getval(z : longint) : byte;
begin
  if (z<0) or (z>=len) then begin
    getval := 128;
    exit;
  end;
  getval := data[z shr 15]^[z and 32767];
end;

procedure putval(z : longint;v : byte);
var
  ln,lni : byte;
begin
  ln := z shr 15;
  if ln>=lno2 then begin
    for lni := ln to lno2 do new(data2[lni]);
    lno2 := ln+1;
  end;
  data2[ln]^[z and 32767] := v;
  if len2<=z then len2 := z+1;
end;

procedure recopy;
var
  lni : byte;
begin
  if lno1<lno2 then
    for lni := lno1 to lno2-1 do new(data[lni]);
  for lni := 0 to lno2-1 do data[lni]^ := data2[lni]^;
  len := len2;
end;

begin
  textattr := $1F;
  write('File to treat : ':40);
  readln(s);
  assign(f,s+'.VOC');
  reset(f,1);
  blockread(f,header,sizeof(header));
  add := header.add;
  seek(f,add);
  blockread(f,b,1);
  if b<>1 then begin
    writeln('Unknown block type!');
    halt;
  end;
  len := 0;
  blockread(f,len,3);
  dec(len,2);
  blockread(f,sr,1);
  blockread(f,pk,1);
  if pk<>0 then begin
    writeln('FILE IS PACKED!');
    halt;
  end;
  lno1 := len shr 15+1;
  for i := 0 to lno1-1 do new(data[i]);
  for i := 0 to lno1-1 do blockread(f,data[i]^,32768,w);
  lno2 := 0;
  len2 := 0;
  writeln('Old sampling rate : ':40,1000000 div (256-sr));
  write('New sampling rate : ':40);
  readln(i);
  sr := 256-(1000000 div i);
  write('Silence value : ':40);
  readln(j);
  for i := 0 to len-1 do begin
    l := getval(i);
    putval(i,l+128-j);
  end;
  recopy;
  write('Initial cutoff : ':40);
  readln(l);
  if l<>0 then begin
    for k := 0 to lno2-1 do dispose(data2[k]);
    lno2 := 0;
    j := len-l;
    len2 := j;
    for i := 0 to j-1 do putval(i,getval(i+l));
    recopy;
  end;
  write('Time multiplicator : ':40);
  readln(tm);
  if tm<>0 then begin
    for k := 0 to lno2-1 do dispose(data2[k]);
    lno2 := 0;
    j := trunc(len*tm+0.5);
    len2 := j;
    for i := 0 to j-1 do begin
      l := trunc(i/tm);
      y1 := getval(l);
      y2 := getval(l+1);
      x1 := l*tm;
      x2 := (l+1)*tm;
      z := y1 + (i-x1)*(y2-y1)/(x2-x1);
      putval(i,trunc(z+0.5));
    end;
    recopy;
  end;
  write('Equalizer? (Y/N) : ':40);
  repeat
    c := readkey;
    c := upcase(c);
  until (c='Y') or (c='N');
  writeln(c);
  if c='Y' then begin
    step := 0.05;
    subdiv := 10;
    for k := 0 to 12 do begin
      q[k] := 0;
      qd[k] := 0;
      r[k] := 4;
      ac[k] := sqrt(0.4*pi)*frq[k];
      l_[k] := sqrt(0.1)/(sqrt(pi)*frq[k]);
      write('Frequency ':25,frq[k]*step*8000:7:2,' band : ');
      readln(equal[k]);
    end;
    step := step/subdiv;
    for i := 0 to len-1 do begin
      if i and $1F=0 then begin
        gotoxy(1,wherey);
        write(i*100 div len:3,'%');
      end;
      e := getval(i)-128;
      for j := 0 to subdiv-1 do begin
        for k := 0 to 12 do begin
          if l_[k]<>0 then begin
            qdd[k] := (e-r[k]*qd[k]-ac[k]*q[k])/l_[k];
            q[k] := q[k]+step*qd[k]+step*step*qdd[k]/2;
            qd[k] := qd[k]+step*qdd[k];
          end else if r[k]<>0 then begin
            qd[k] := (e-ac[k]*q[k])/r[k];
            q[k] := q[k]+step*qd[k];
          end else begin
            qd[k] := (e/ac[k]-q[k])/step;
            q[k] := e/ac[k];
          end;
        end;
      end;
      outs := 0;
      for k := 0 to 12 do outs := outs+qd[k]*equal[k];
      putval(i,trunc(outs+128.5));
    end;
    gotoxy(1,wherey);
    clreol;
    recopy;
  end;
  write('Invert? (Y/N) : ':40);
  repeat
    c := readkey;
    c := upcase(c);
  until (c='Y') or (c='N');
  writeln(c);
  if c='Y' then begin
    for i := 0 to len-1 do putval(i,getval(len-1-i));
    recopy;
  end;
  write('Echo chamber length : ':40);
  readln(echolen);
  if echolen>0 then begin
    if echolen>4000 then echolen := 4000;
    write('Echo chamber attenuation : ':40);
    readln(echoatt);
    for i := 0 to echolen-1 do echo[i] := 0;
    for i := 0 to len-1+echolen*2 do begin
      j := i mod echolen;
      echo[j] := echoatt*echo[j] + getval(i)-128;
      putval(i,trunc(echo[j]+128.5));
    end;
    recopy;
  end;
  write('Volume control? (Y/N) : ':40);
  repeat
    c := readkey;
    c := upcase(c);
  until (c='Y') or (c='N');
  writeln(c);
  if c='Y' then begin
    write('Zero displacement : ':40);
    readln(zdsp);
    write('Positive factor : ':40);
    readln(pfct);
    write('Positive displacement : ':40);
    readln(pdsp);
    write('Positive quadratic : ':40);
    readln(pqdt);
    write('Negative factor : ':40);
    readln(nfct);
    write('Negative displacement : ':40);
    readln(ndsp);
    write('Negative quadratic : ':40);
    readln(nqdt);
    for i := 0 to len-1 do begin
      v1 := getval(i)/128 - 1;
      if v1=0 then v2 := zdsp
      else if v1>0 then v2 := pfct*v1+pdsp+pqdt*v1*v1
      else if v1<0 then v2 := nfct*v1+ndsp+nqdt*v1*v1;
      putval(i,trunc(v2*128+128.5));
    end;
    recopy;
  end;
  write('Volume time-dependence? (Y/N) : ':40);
  repeat
    c := readkey;
    c := upcase(c);
  until (c='Y') or (c='N');
  writeln(c);
  if c='Y' then begin
    write('Initial volume factor : ':40);
    readln(vini);
    writeln('Total length : ':40,len);
    write('Middle point : ':40);
    readln(midp);
    write('Middle point volume factor : ':40);
    readln(vmid);
    write('Final volume factor : ':40);
    readln(vfin);
    for i := 0 to len-1 do begin
      v1 := getval(i)/128-1;
      if i<midp then v2 := v1*(vini+(vmid-vini)*i/midp)
      else v2 := v1*(vmid+(vfin-vmid)*(i-midp)/(len-midp));
      putval(i,trunc(v2*128+128.5));
    end;
    recopy;
  end;
  write('Invert? (Y/N) : ':40);
  repeat
    c := readkey;
    c := upcase(c);
  until (c='Y') or (c='N');
  writeln(c);
  if c='Y' then begin
    for i := 0 to len-1 do putval(i,getval(len-1-i));
    recopy;
  end;
  regs.ax := $005E;
  intr($10,regs);
  k := 1;
  while len shr k>=800 do inc(k);
  for i := 0 to len shr k do putdot(i,127,12);
  for i := 0 to len-1 do begin
    j := getval(i);
    putdot(i shr k,255-j,15);
  end;
  for i := 0 to 799 do begin
    putdot(i,385,12);
    putdot(i,512-getval(i),15);
  end;
  c := readkey;
  textmode(co80);
  assign(g,'TREAT.VOC');
  rewrite(g,1);
  header.add := sizeof(header);
  blockwrite(g,header,sizeof(header));
  b := 1;
  blockwrite(g,b,1);
  i := len2+2;
  blockwrite(g,i,3);
  blockwrite(g,sr,1);
  blockwrite(g,pk,1);
  for i := 0 to lno2-2 do blockwrite(g,data2[i]^,32768);
  blockwrite(g,data2[lno2-1]^,len2 and 32767);
  b := 0;
  blockwrite(g,b,1);
end.